
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         octave_parse
#define yylex           octave_lex
#define yyerror         octave_error
#define yylval          octave_lval
#define yychar          octave_char
#define yydebug         octave_debug
#define yynerrs         octave_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 29 "parse.y"

#define YYDEBUG 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cassert>
#include <cstdio>

#ifdef YYBYACC
#include <cstdlib>
#endif

#include <iostream>
#include <map>
#include <sstream>

#include "Cell.h"
#include "Matrix.h"
#include "cmd-edit.h"
#include "cmd-hist.h"
#include "file-ops.h"
#include "file-stat.h"
#include "oct-env.h"
#include "oct-time.h"
#include "quit.h"

#include "comment-list.h"
#include "defaults.h"
#include "defun.h"
#include "dirfns.h"
#include "dynamic-ld.h"
#include "error.h"
#include "input.h"
#include "lex.h"
#include "load-path.h"
#include "oct-hist.h"
#include "oct-map.h"
#include "ov-fcn-handle.h"
#include "ov-usr-fcn.h"
#include "ov-null-mat.h"
#include "toplev.h"
#include "pager.h"
#include "parse.h"
#include "pt-all.h"
#include "pt-eval.h"
#include "symtab.h"
#include "token.h"
#include "unwind-prot.h"
#include "utils.h"
#include "variables.h"

// The current input line number.
int input_line_number = 1;

// The column of the current token.
int current_input_column = 1;

// Buffer for help text snagged from function files.
std::stack<std::string> help_buf;

// Buffer for comments appearing before a function statement.
static std::string fcn_comment_header;

// TRUE means we are using readline.
// (--no-line-editing)
bool line_editing = true;

// TRUE means we printed messages about reading startup files.
bool reading_startup_message_printed = false;

// TRUE means input is coming from startup file.
bool input_from_startup_file = false;

// = 0 currently outside any function.
// = 1 inside the primary function or a subfunction.
// > 1 means we are looking at a function definition that seems to be
//     inside a function. Note that the function still might not be a
//     nested function.
static int current_function_depth = 0;

// Maximum function depth detected. Just here to determine whether
// we have nested functions or just implicitly ended subfunctions.
static int max_function_depth = 0;

// FALSE if we are still at the primary function. Subfunctions can
// only be declared inside function files.
static int parsing_subfunctions = false;

// Have we found an explicit end to a function?
static bool endfunction_found = false;

// Keep track of symbol table information when parsing functions.
std::stack<symbol_table::scope_id> symtab_context;

// Name of the current class when we are parsing class methods or
// constructors.
std::string current_class_name;

// TRUE means we are in the process of autoloading a function.
static bool autoloading = false;

// TRUE means the current function file was found in a relative path
// element.
static bool fcn_file_from_relative_lookup = false;

// Pointer to the primary user function or user script function.
static octave_function *primary_fcn_ptr = 0;

// Scope where we install all subfunctions and nested functions. Only
// used while reading function files.
static symbol_table::scope_id primary_fcn_scope;

// List of autoloads (function -> file mapping).
static std::map<std::string, std::string> autoload_map;

// Forward declarations for some functions defined at the bottom of
// the file.

// Generic error messages.
static void
yyerror (const char *s);

// Error mesages for mismatched end tokens.
static void
end_error (const char *type, token::end_tok_type ettype, int l, int c);

// Check to see that end tokens are properly matched.
static bool
end_token_ok (token *tok, token::end_tok_type expected);

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.
static void
maybe_warn_assign_as_truth_value (tree_expression *expr);

// Maybe print a warning about switch labels that aren't constants.
static void
maybe_warn_variable_switch_label (tree_expression *expr);

// Finish building a range.
static tree_expression *
finish_colon_expression (tree_colon_expression *e);

// Build a constant.
static tree_constant *
make_constant (int op, token *tok_val);

// Build a function handle.
static tree_fcn_handle *
make_fcn_handle (token *tok_val);

// Build an anonymous function handle.
static tree_anon_fcn_handle *
make_anon_fcn_handle (tree_parameter_list *param_list, tree_statement *stmt);

// Build a binary expression.
static tree_expression *
make_binary_op (int op, tree_expression *op1, token *tok_val,
		tree_expression *op2);

// Build a boolean expression.
static tree_expression *
make_boolean_op (int op, tree_expression *op1, token *tok_val,
		 tree_expression *op2);

// Build a prefix expression.
static tree_expression *
make_prefix_op (int op, tree_expression *op1, token *tok_val);

// Build a postfix expression.
static tree_expression *
make_postfix_op (int op, tree_expression *op1, token *tok_val);

// Build an unwind-protect command.
static tree_command *
make_unwind_command (token *unwind_tok, tree_statement_list *body,
		     tree_statement_list *cleanup, token *end_tok,
		     octave_comment_list *lc, octave_comment_list *mc);

// Build a try-catch command.
static tree_command *
make_try_command (token *try_tok, tree_statement_list *body,
		  tree_statement_list *cleanup, token *end_tok,
		  octave_comment_list *lc, octave_comment_list *mc);

// Build a while command.
static tree_command *
make_while_command (token *while_tok, tree_expression *expr,
		    tree_statement_list *body, token *end_tok,
		    octave_comment_list *lc);

// Build a do-until command.
static tree_command *
make_do_until_command (token *until_tok, tree_statement_list *body,
		       tree_expression *expr, octave_comment_list *lc);

// Build a for command.
static tree_command *
make_for_command (token *for_tok, tree_argument_list *lhs,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok, octave_comment_list *lc);

// Build a break command.
static tree_command *
make_break_command (token *break_tok);

// Build a continue command.
static tree_command *
make_continue_command (token *continue_tok);

// Build a return command.
static tree_command *
make_return_command (token *return_tok);

// Start an if command.
static tree_if_command_list *
start_if_command (tree_expression *expr, tree_statement_list *list);

// Finish an if command.
static tree_if_command *
finish_if_command (token *if_tok, tree_if_command_list *list,
		   token *end_tok, octave_comment_list *lc);

// Build an elseif clause.
static tree_if_clause *
make_elseif_clause (token *elseif_tok, tree_expression *expr,
		    tree_statement_list *list, octave_comment_list *lc);

// Finish a switch command.
static tree_switch_command *
finish_switch_command (token *switch_tok, tree_expression *expr,
		       tree_switch_case_list *list, token *end_tok,
		       octave_comment_list *lc);

// Build a switch case.
static tree_switch_case *
make_switch_case (token *case_tok, tree_expression *expr,
		  tree_statement_list *list, octave_comment_list *lc);

// Build an assignment to a variable.
static tree_expression *
make_assign_op (int op, tree_argument_list *lhs, token *eq_tok,
		tree_expression *rhs);

// Define a script.
static void
make_script (tree_statement_list *cmds, tree_statement *end_script);

// Begin defining a function.
static octave_user_function *
start_function (tree_parameter_list *param_list, tree_statement_list *body,
		tree_statement *end_function);

// Create a no-op statement for end_function.
static tree_statement *
make_end (const std::string& type, int l, int c);

// Do most of the work for defining a function.
static octave_user_function *
frob_function (const std::string& fname, octave_user_function *fcn);

// Finish defining a function.
static tree_function_def *
finish_function (tree_parameter_list *ret_list,
		 octave_user_function *fcn, octave_comment_list *lc);

// Reset state after parsing function.
static void
recover_from_parsing_function (void);

// Make an index expression.
static tree_index_expression *
make_index_expression (tree_expression *expr,
		       tree_argument_list *args, char type);

// Make an indirect reference expression.
static tree_index_expression *
make_indirect_ref (tree_expression *expr, const std::string&);

// Make an indirect reference expression with dynamic field name.
static tree_index_expression *
make_indirect_ref (tree_expression *expr, tree_expression *field);

// Make a declaration command.
static tree_decl_command *
make_decl_command (int tok, token *tok_val, tree_decl_init_list *lst);

// Finish building a matrix list.
static tree_expression *
finish_matrix (tree_matrix *m);

// Finish building a cell list.
static tree_expression *
finish_cell (tree_cell *c);

// Maybe print a warning.  Duh.
static void
maybe_warn_missing_semi (tree_statement_list *);

// Set the print flag for a statement based on the separator type.
static tree_statement_list *
set_stmt_print_flag (tree_statement_list *, char, bool);

// Create a statement list.
static tree_statement_list *make_statement_list (tree_statement *stmt);

// Append a statement to an existing statement list.
static tree_statement_list *
append_statement_list (tree_statement_list *list, char sep,
		       tree_statement *stmt, bool warn_missing_semi);

// Finish building a statement.
template <class T>
static tree_statement *
make_statement (T *arg)
{
  octave_comment_list *comment = octave_comment_buffer::get_comment ();

  return new tree_statement (arg, comment);
}

#define ABORT_PARSE \
  do \
    { \
      global_command = 0; \
      yyerrok; \
      if (! symtab_context.empty ()) \
        { \
	  symbol_table::set_scope (symtab_context.top ()); \
	  symtab_context.pop (); \
        } \
      if (interactive || forced_interactive) \
	YYACCEPT; \
      else \
	YYABORT; \
    } \
  while (0)



/* Line 189 of yacc.c  */
#line 424 "parse.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ADD_EQ = 258,
     SUB_EQ = 259,
     MUL_EQ = 260,
     DIV_EQ = 261,
     LEFTDIV_EQ = 262,
     POW_EQ = 263,
     EMUL_EQ = 264,
     EDIV_EQ = 265,
     ELEFTDIV_EQ = 266,
     EPOW_EQ = 267,
     AND_EQ = 268,
     OR_EQ = 269,
     LSHIFT_EQ = 270,
     RSHIFT_EQ = 271,
     LSHIFT = 272,
     RSHIFT = 273,
     EXPR_AND_AND = 274,
     EXPR_OR_OR = 275,
     EXPR_AND = 276,
     EXPR_OR = 277,
     EXPR_NOT = 278,
     EXPR_LT = 279,
     EXPR_LE = 280,
     EXPR_EQ = 281,
     EXPR_NE = 282,
     EXPR_GE = 283,
     EXPR_GT = 284,
     LEFTDIV = 285,
     EMUL = 286,
     EDIV = 287,
     ELEFTDIV = 288,
     EPLUS = 289,
     EMINUS = 290,
     QUOTE = 291,
     TRANSPOSE = 292,
     PLUS_PLUS = 293,
     MINUS_MINUS = 294,
     POW = 295,
     EPOW = 296,
     NUM = 297,
     IMAG_NUM = 298,
     STRUCT_ELT = 299,
     NAME = 300,
     END = 301,
     DQ_STRING = 302,
     SQ_STRING = 303,
     FOR = 304,
     WHILE = 305,
     DO = 306,
     UNTIL = 307,
     IF = 308,
     ELSEIF = 309,
     ELSE = 310,
     SWITCH = 311,
     CASE = 312,
     OTHERWISE = 313,
     BREAK = 314,
     CONTINUE = 315,
     FUNC_RET = 316,
     UNWIND = 317,
     CLEANUP = 318,
     TRY = 319,
     CATCH = 320,
     GLOBAL = 321,
     STATIC = 322,
     FCN_HANDLE = 323,
     PROPERTIES = 324,
     METHODS = 325,
     EVENTS = 326,
     METAQUERY = 327,
     SUPERCLASSREF = 328,
     GET = 329,
     SET = 330,
     END_OF_INPUT = 331,
     LEXICAL_ERROR = 332,
     FCN = 333,
     SCRIPT_FILE = 334,
     FUNCTION_FILE = 335,
     CLASSDEF = 336,
     CLOSE_BRACE = 337,
     UNARY = 338
   };
#endif
/* Tokens.  */
#define ADD_EQ 258
#define SUB_EQ 259
#define MUL_EQ 260
#define DIV_EQ 261
#define LEFTDIV_EQ 262
#define POW_EQ 263
#define EMUL_EQ 264
#define EDIV_EQ 265
#define ELEFTDIV_EQ 266
#define EPOW_EQ 267
#define AND_EQ 268
#define OR_EQ 269
#define LSHIFT_EQ 270
#define RSHIFT_EQ 271
#define LSHIFT 272
#define RSHIFT 273
#define EXPR_AND_AND 274
#define EXPR_OR_OR 275
#define EXPR_AND 276
#define EXPR_OR 277
#define EXPR_NOT 278
#define EXPR_LT 279
#define EXPR_LE 280
#define EXPR_EQ 281
#define EXPR_NE 282
#define EXPR_GE 283
#define EXPR_GT 284
#define LEFTDIV 285
#define EMUL 286
#define EDIV 287
#define ELEFTDIV 288
#define EPLUS 289
#define EMINUS 290
#define QUOTE 291
#define TRANSPOSE 292
#define PLUS_PLUS 293
#define MINUS_MINUS 294
#define POW 295
#define EPOW 296
#define NUM 297
#define IMAG_NUM 298
#define STRUCT_ELT 299
#define NAME 300
#define END 301
#define DQ_STRING 302
#define SQ_STRING 303
#define FOR 304
#define WHILE 305
#define DO 306
#define UNTIL 307
#define IF 308
#define ELSEIF 309
#define ELSE 310
#define SWITCH 311
#define CASE 312
#define OTHERWISE 313
#define BREAK 314
#define CONTINUE 315
#define FUNC_RET 316
#define UNWIND 317
#define CLEANUP 318
#define TRY 319
#define CATCH 320
#define GLOBAL 321
#define STATIC 322
#define FCN_HANDLE 323
#define PROPERTIES 324
#define METHODS 325
#define EVENTS 326
#define METAQUERY 327
#define SUPERCLASSREF 328
#define GET 329
#define SET 330
#define END_OF_INPUT 331
#define LEXICAL_ERROR 332
#define FCN 333
#define SCRIPT_FILE 334
#define FUNCTION_FILE 335
#define CLASSDEF 336
#define CLOSE_BRACE 337
#define UNARY 338




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 379 "parse.y"

  // The type of the basic tokens returned by the lexer.
  token *tok_val;

  // Comment strings that we need to deal with mid-rule.
  octave_comment_list *comment_type;

  // Types for the nonterminals we generate.
  char sep_type;
  tree *tree_type;
  tree_matrix *tree_matrix_type;
  tree_cell *tree_cell_type;
  tree_expression *tree_expression_type;
  tree_constant *tree_constant_type;
  tree_fcn_handle *tree_fcn_handle_type;
  tree_anon_fcn_handle *tree_anon_fcn_handle_type;
  tree_identifier *tree_identifier_type;
  tree_index_expression *tree_index_expression_type;
  tree_colon_expression *tree_colon_expression_type;
  tree_argument_list *tree_argument_list_type;
  tree_parameter_list *tree_parameter_list_type;
  tree_command *tree_command_type;
  tree_if_command *tree_if_command_type;
  tree_if_clause *tree_if_clause_type;
  tree_if_command_list *tree_if_command_list_type;
  tree_switch_command *tree_switch_command_type;
  tree_switch_case *tree_switch_case_type;
  tree_switch_case_list *tree_switch_case_list_type;
  tree_decl_elt *tree_decl_elt_type;
  tree_decl_init_list *tree_decl_init_list_type;
  tree_decl_command *tree_decl_command_type;
  tree_statement *tree_statement_type;
  tree_statement_list *tree_statement_list_type;
  octave_user_function *octave_user_function_type;
  void *dummy_type;



/* Line 214 of yacc.c  */
#line 665 "parse.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 677 "parse.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  123
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1189

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  101
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  102
/* YYNRULES -- Number of rules.  */
#define YYNRULES  258
/* YYNRULES -- Number of states.  */
#define YYNSTATES  461

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   338

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      91,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      93,   100,     7,     6,    90,     5,    94,     8,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    89,
       2,     3,     2,     2,    99,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    96,     2,    97,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    95,     2,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    92
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      21,    24,    27,    29,    33,    34,    36,    39,    41,    45,
      47,    49,    51,    54,    56,    59,    61,    63,    65,    67,
      69,    71,    73,    75,    78,    82,    86,    90,    92,    95,
      97,   101,   104,   108,   112,   114,   117,   119,   123,   125,
     128,   131,   135,   137,   139,   141,   143,   145,   147,   149,
     153,   155,   157,   159,   163,   167,   169,   171,   175,   180,
     184,   189,   192,   195,   198,   201,   205,   211,   213,   215,
     218,   221,   224,   227,   230,   234,   238,   242,   246,   250,
     254,   258,   262,   266,   270,   274,   278,   280,   282,   286,
     288,   292,   296,   300,   304,   308,   312,   316,   320,   324,
     328,   332,   336,   338,   342,   346,   350,   354,   358,   362,
     366,   370,   374,   378,   382,   386,   390,   394,   398,   402,
     404,   406,   408,   410,   412,   414,   416,   418,   420,   422,
     424,   425,   429,   433,   435,   438,   439,   441,   446,   448,
     450,   455,   457,   460,   464,   467,   474,   479,   486,   487,
     489,   492,   494,   497,   504,   509,   516,   523,   532,   543,
     545,   547,   549,   559,   569,   575,   576,   578,   580,   584,
     587,   588,   590,   592,   596,   599,   601,   605,   607,   611,
     615,   620,   622,   626,   630,   633,   638,   640,   644,   648,
     651,   656,   660,   662,   664,   667,   669,   674,   681,   682,
     686,   688,   692,   694,   699,   702,   703,   705,   710,   713,
     719,   723,   725,   727,   729,   733,   737,   741,   744,   751,
     753,   757,   759,   765,   768,   775,   777,   781,   784,   791,
     793,   797,   799,   800,   802,   804,   806,   808,   811,   814,
     815,   817,   819,   821,   823,   826,   829,   832,   833
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     102,     0,    -1,   103,    -1,   168,    -1,   104,   198,    -1,
     198,    -1,    91,    -1,    82,    -1,   104,    -1,   104,    91,
      -1,   104,    82,    -1,   105,   200,    -1,   109,    -1,   105,
     199,   109,    -1,    -1,   107,    -1,   108,   202,    -1,   109,
      -1,   108,   201,   109,    -1,   138,    -1,   139,    -1,   110,
      -1,   112,   111,    -1,   115,    -1,   111,   115,    -1,    51,
      -1,    79,    -1,    78,    -1,    53,    -1,    54,    -1,    48,
      -1,    49,    -1,   115,    -1,    96,    97,    -1,    96,    89,
      97,    -1,    96,    90,    97,    -1,    96,   118,    97,    -1,
     119,    -1,   119,    89,    -1,   123,    -1,   119,    89,   123,
      -1,    95,    98,    -1,    95,    89,    98,    -1,    95,   121,
      98,    -1,   122,    -1,   122,    89,    -1,   123,    -1,   122,
      89,   123,    -1,   128,    -1,   128,    90,    -1,    99,    74,
      -1,    99,   162,   109,    -1,   112,    -1,   116,    -1,   124,
      -1,   117,    -1,   120,    -1,   114,    -1,   113,    -1,    93,
     138,   100,    -1,     4,    -1,   138,    -1,   127,    -1,   128,
      90,   127,    -1,   128,    90,   138,    -1,    94,    -1,   126,
      -1,   130,    93,   100,    -1,   130,    93,   128,   100,    -1,
     130,    95,    98,    -1,   130,    95,   128,    98,    -1,   130,
      44,    -1,   130,    45,    -1,   130,    42,    -1,   130,    43,
      -1,   130,   129,    50,    -1,   130,   129,    93,   138,   100,
      -1,   130,    -1,   132,    -1,    44,   131,    -1,    45,   131,
      -1,    29,   131,    -1,     6,   131,    -1,     5,   131,    -1,
     131,    46,   131,    -1,   131,    47,   131,    -1,   131,     6,
     131,    -1,   131,     5,   131,    -1,   131,     7,   131,    -1,
     131,     8,   131,    -1,   131,    40,   131,    -1,   131,    41,
     131,    -1,   131,    37,   131,    -1,   131,    38,   131,    -1,
     131,    36,   131,    -1,   131,    39,   131,    -1,   134,    -1,
     131,    -1,   134,     4,   131,    -1,   133,    -1,   135,    23,
     135,    -1,   135,    24,   135,    -1,   135,    30,   135,    -1,
     135,    31,   135,    -1,   135,    32,   135,    -1,   135,    34,
     135,    -1,   135,    35,   135,    -1,   135,    33,   135,    -1,
     135,    27,   135,    -1,   135,    28,   135,    -1,   135,    25,
     135,    -1,   135,    26,   135,    -1,   135,    -1,    96,   128,
      88,    -1,   136,     3,   138,    -1,   136,     9,   138,    -1,
     136,    10,   138,    -1,   136,    11,   138,    -1,   136,    12,
     138,    -1,   136,    13,   138,    -1,   136,    14,   138,    -1,
     136,    21,   138,    -1,   136,    22,   138,    -1,   136,    15,
     138,    -1,   136,    16,   138,    -1,   136,    17,   138,    -1,
     136,    18,   138,    -1,   136,    19,   138,    -1,   136,    20,
     138,    -1,   135,    -1,   137,    -1,   125,    -1,   141,    -1,
     145,    -1,   156,    -1,   157,    -1,   158,    -1,   171,    -1,
     167,    -1,   179,    -1,    -1,    72,   140,   142,    -1,    73,
     140,   142,    -1,   144,    -1,   142,   144,    -1,    -1,   112,
      -1,   112,     3,   143,   138,    -1,   146,    -1,   151,    -1,
      59,   197,   147,    52,    -1,   148,    -1,   148,   150,    -1,
     138,   202,   106,    -1,   148,   149,    -1,    60,   197,   202,
     138,   202,   106,    -1,    61,   197,   202,   106,    -1,    62,
     197,   138,   202,   152,    52,    -1,    -1,   153,    -1,   153,
     155,    -1,   154,    -1,   153,   154,    -1,    63,   197,   202,
     138,   202,   106,    -1,    64,   197,   202,   106,    -1,    56,
     197,   138,   202,   106,    52,    -1,    57,   197,   202,   106,
      58,   138,    -1,    55,   197,   136,     3,   138,   202,   106,
      52,    -1,    55,   197,    93,   136,     3,   138,   100,   202,
     106,    52,    -1,    65,    -1,    66,    -1,    67,    -1,    68,
     197,   202,   106,    69,   197,   202,   106,    52,    -1,    70,
     197,   202,   106,    71,   197,   202,   106,    52,    -1,    70,
     197,   202,   106,    52,    -1,    -1,    93,    -1,   100,    -1,
     160,   163,   161,    -1,   160,     1,    -1,    -1,   164,    -1,
     144,    -1,   164,    90,   144,    -1,    96,    97,    -1,   166,
      -1,    96,   166,    97,    -1,   112,    -1,   166,    90,   112,
      -1,    85,   106,    82,    -1,    86,   169,   202,    82,    -1,
     171,    -1,   169,   201,   171,    -1,   159,    84,   197,    -1,
     170,   173,    -1,   170,   165,     3,   173,    -1,   112,    -1,
      80,    94,   112,    -1,    81,    94,   112,    -1,   172,   174,
      -1,   162,   202,   106,   175,    -1,   202,   106,   175,    -1,
      52,    -1,    82,    -1,    87,   197,    -1,    52,    -1,   176,
     180,   112,   183,    -1,   178,    91,   185,    91,   197,   177,
      -1,    -1,    93,   181,   100,    -1,   182,    -1,   181,    90,
     182,    -1,   112,    -1,   112,     3,   143,   138,    -1,    29,
     112,    -1,    -1,   184,    -1,    30,   112,    94,   112,    -1,
      30,   112,    -1,   184,    27,   112,    94,   112,    -1,   184,
      27,   112,    -1,   187,    -1,   191,    -1,   194,    -1,   185,
      91,   187,    -1,   185,    91,   191,    -1,   185,    91,   194,
      -1,    75,   197,    -1,   186,   180,    91,   188,    91,    52,
      -1,   189,    -1,   188,    91,   189,    -1,   112,    -1,   112,
       3,   143,   138,    89,    -1,    76,   197,    -1,   190,   180,
      91,   192,    91,    52,    -1,   171,    -1,   192,    91,   171,
      -1,    77,   197,    -1,   193,   180,    91,   195,    91,    52,
      -1,   196,    -1,   195,    91,   196,    -1,   112,    -1,    -1,
      83,    -1,     1,    -1,    90,    -1,    89,    -1,   199,    90,
      -1,   199,    89,    -1,    -1,   199,    -1,    90,    -1,    89,
      -1,    91,    -1,   201,    90,    -1,   201,    89,    -1,   201,
      91,    -1,    -1,   201,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   531,   531,   537,   541,   543,   547,   549,   554,   556,
     558,   562,   566,   568,   573,   574,   578,   582,   584,   588,
     590,   592,   604,   608,   610,   621,   629,   633,   637,   639,
     643,   645,   647,   651,   657,   663,   669,   677,   679,   683,
     685,   692,   694,   696,   700,   702,   706,   708,   716,   718,
     722,   729,   733,   735,   737,   739,   741,   743,   745,   747,
     751,   758,   760,   762,   767,   774,   778,   780,   782,   784,
     786,   788,   790,   792,   794,   796,   798,   802,   804,   806,
     808,   810,   812,   814,   818,   820,   822,   824,   826,   828,
     830,   832,   834,   836,   838,   840,   844,   848,   850,   857,
     859,   861,   863,   865,   867,   869,   871,   873,   875,   877,
     879,   881,   888,   893,   907,   909,   911,   913,   915,   917,
     919,   921,   923,   925,   927,   929,   931,   933,   935,   939,
     941,   943,   951,   953,   955,   957,   959,   961,   963,   965,
     975,   977,   982,   989,   991,   999,  1001,  1003,  1014,  1016,
    1024,  1031,  1033,  1040,  1042,  1049,  1053,  1061,  1069,  1070,
    1072,  1079,  1081,  1088,  1092,  1102,  1107,  1112,  1117,  1128,
    1133,  1138,  1149,  1155,  1161,  1173,  1195,  1208,  1215,  1220,
    1229,  1230,  1240,  1242,  1253,  1258,  1266,  1276,  1278,  1289,
    1305,  1309,  1310,  1317,  1326,  1331,  1338,  1348,  1353,  1360,
    1371,  1373,  1377,  1385,  1423,  1430,  1441,  1445,  1450,  1451,
    1455,  1457,  1461,  1463,  1465,  1471,  1472,  1476,  1478,  1480,
    1482,  1486,  1488,  1490,  1492,  1494,  1496,  1500,  1505,  1510,
    1512,  1516,  1518,  1522,  1526,  1530,  1532,  1536,  1540,  1544,
    1546,  1550,  1559,  1562,  1564,  1567,  1569,  1571,  1573,  1578,
    1579,  1583,  1585,  1587,  1589,  1591,  1593,  1598,  1599
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'='", "':'", "'-'", "'+'", "'*'", "'/'",
  "ADD_EQ", "SUB_EQ", "MUL_EQ", "DIV_EQ", "LEFTDIV_EQ", "POW_EQ",
  "EMUL_EQ", "EDIV_EQ", "ELEFTDIV_EQ", "EPOW_EQ", "AND_EQ", "OR_EQ",
  "LSHIFT_EQ", "RSHIFT_EQ", "LSHIFT", "RSHIFT", "EXPR_AND_AND",
  "EXPR_OR_OR", "EXPR_AND", "EXPR_OR", "EXPR_NOT", "EXPR_LT", "EXPR_LE",
  "EXPR_EQ", "EXPR_NE", "EXPR_GE", "EXPR_GT", "LEFTDIV", "EMUL", "EDIV",
  "ELEFTDIV", "EPLUS", "EMINUS", "QUOTE", "TRANSPOSE", "PLUS_PLUS",
  "MINUS_MINUS", "POW", "EPOW", "NUM", "IMAG_NUM", "STRUCT_ELT", "NAME",
  "END", "DQ_STRING", "SQ_STRING", "FOR", "WHILE", "DO", "UNTIL", "IF",
  "ELSEIF", "ELSE", "SWITCH", "CASE", "OTHERWISE", "BREAK", "CONTINUE",
  "FUNC_RET", "UNWIND", "CLEANUP", "TRY", "CATCH", "GLOBAL", "STATIC",
  "FCN_HANDLE", "PROPERTIES", "METHODS", "EVENTS", "METAQUERY",
  "SUPERCLASSREF", "GET", "SET", "END_OF_INPUT", "LEXICAL_ERROR", "FCN",
  "SCRIPT_FILE", "FUNCTION_FILE", "CLASSDEF", "CLOSE_BRACE", "';'", "','",
  "'\\n'", "UNARY", "'('", "'.'", "'{'", "'['", "']'", "'}'", "'@'", "')'",
  "$accept", "input", "input1", "simple_list", "simple_list1", "opt_list",
  "list", "list1", "statement", "word_list_cmd", "word_list", "identifier",
  "superclass_identifier", "meta_identifier", "string", "constant",
  "matrix", "matrix_rows", "matrix_rows1", "cell", "cell_rows",
  "cell_rows1", "cell_or_matrix_row", "fcn_handle", "anon_fcn_handle",
  "primary_expr", "magic_colon", "arg_list", "indirect_ref_op",
  "postfix_expr", "prefix_expr", "binary_expr", "colon_expr",
  "colon_expr1", "simple_expr", "assign_lhs", "assign_expr", "expression",
  "command", "parsing_decl_list", "declaration", "decl1",
  "decl_param_init", "decl2", "select_command", "if_command",
  "if_cmd_list", "if_cmd_list1", "elseif_clause", "else_clause",
  "switch_command", "case_list", "case_list1", "switch_case",
  "default_case", "loop_command", "jump_command", "except_command",
  "push_fcn_symtab", "param_list_beg", "param_list_end", "param_list",
  "param_list1", "param_list2", "return_list", "return_list1",
  "script_file", "function_file", "function_list", "function_beg",
  "function", "fcn_name", "function1", "function2", "function_end",
  "classdef_beg", "classdef_end", "classdef1", "classdef", "opt_attr_list",
  "attr_list", "attr", "opt_superclasses", "superclasses", "class_body",
  "properties_beg", "properties_block", "properties_list",
  "class_property", "methods_beg", "methods_block", "methods_list",
  "events_beg", "events_block", "events_list", "class_event",
  "stash_comment", "parse_error", "sep_no_nl", "opt_sep_no_nl", "sep",
  "opt_sep", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    61,    58,    45,    43,    42,    47,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,    59,
      44,    10,   338,    40,    46,   123,    91,    93,   125,    64,
      41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   101,   102,   102,   102,   102,   103,   103,   103,   103,
     103,   104,   105,   105,   106,   106,   107,   108,   108,   109,
     109,   109,   110,   111,   111,   112,   113,   114,   115,   115,
     116,   116,   116,   117,   117,   117,   117,   118,   118,   119,
     119,   120,   120,   120,   121,   121,   122,   122,   123,   123,
     124,   125,   126,   126,   126,   126,   126,   126,   126,   126,
     127,   128,   128,   128,   128,   129,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   131,   131,   131,
     131,   131,   131,   131,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   133,   134,   134,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   136,   136,   137,   137,   137,   137,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   138,
     138,   138,   139,   139,   139,   139,   139,   139,   139,   139,
     140,   141,   141,   142,   142,   143,   144,   144,   145,   145,
     146,   147,   147,   148,   148,   149,   150,   151,   152,   152,
     152,   153,   153,   154,   155,   156,   156,   156,   156,   157,
     157,   157,   158,   158,   158,   159,   160,   161,   162,   162,
     163,   163,   164,   164,   165,   165,   165,   166,   166,   167,
     168,   169,   169,   170,   171,   171,   172,   172,   172,   173,
     174,   174,   175,   175,   176,   177,   178,   179,   180,   180,
     181,   181,   182,   182,   182,   183,   183,   184,   184,   184,
     184,   185,   185,   185,   185,   185,   185,   186,   187,   188,
     188,   189,   189,   190,   191,   192,   192,   193,   194,   195,
     195,   196,   197,   198,   198,   199,   199,   199,   199,   200,
     200,   201,   201,   201,   201,   201,   201,   202,   202
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     2,
       2,     2,     1,     3,     0,     1,     2,     1,     3,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     3,     1,     2,     1,
       3,     2,     3,     3,     1,     2,     1,     3,     1,     2,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     3,     3,     1,     1,     3,     4,     3,
       4,     2,     2,     2,     2,     3,     5,     1,     1,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     3,     1,     2,     0,     1,     4,     1,     1,
       4,     1,     2,     3,     2,     6,     4,     6,     0,     1,
       2,     1,     2,     6,     4,     6,     6,     8,    10,     1,
       1,     1,     9,     9,     5,     0,     1,     1,     3,     2,
       0,     1,     1,     3,     2,     1,     3,     1,     3,     3,
       4,     1,     3,     3,     2,     4,     1,     3,     3,     2,
       4,     3,     1,     1,     2,     1,     4,     6,     0,     3,
       1,     3,     1,     4,     2,     0,     1,     4,     2,     5,
       3,     1,     1,     1,     3,     3,     3,     2,     6,     1,
       3,     1,     5,     2,     6,     1,     3,     2,     6,     1,
       3,     1,     0,     1,     1,     1,     1,     2,     2,     0,
       1,     1,     1,     1,     2,     2,     2,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,   244,     0,     0,     0,     0,     0,    30,    31,    25,
      28,    29,   242,   242,   242,   242,   242,   169,   170,   171,
     242,   242,   140,   140,    27,    26,     7,   243,    14,   175,
     242,     6,     0,     0,     0,     0,     0,     2,     0,   249,
      12,    21,    52,    58,    57,    32,    53,    55,    56,    54,
     131,    66,    77,    97,    78,    99,    96,   129,     0,   130,
      19,    20,   132,   133,   148,   149,   134,   135,   136,     0,
     138,     3,     0,   137,   208,     0,   139,     5,     0,     0,
      52,    83,    82,    81,    79,    80,     0,     0,   257,     0,
       0,   257,   257,     0,     0,     0,    15,   257,    17,   257,
     191,   204,     0,    60,     0,    41,     0,    44,    46,    62,
      48,    61,     0,     0,    33,     0,    37,    39,    48,    50,
     176,     0,   175,     1,    10,     9,     4,   246,   245,   250,
      11,    22,    23,    73,    74,    71,    72,     0,    65,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   242,     0,     0,     0,   196,     0,   185,   257,   194,
       0,     0,     0,     0,   112,     0,   257,   252,   251,   253,
     258,    14,   257,     0,   151,   257,    14,    14,   146,   141,
     143,   142,   189,   258,    16,   175,     0,    59,    42,    43,
      45,    49,    34,    35,    36,    38,   113,   179,   182,     0,
     181,    51,   248,   247,    13,    24,    67,     0,    69,     0,
      75,     0,    87,    86,    88,    89,    94,    92,    93,    95,
      90,    91,    84,    85,    98,   100,   101,   110,   111,   108,
     109,   102,   103,   104,   107,   105,   106,   114,   115,   116,
     117,   118,   119,   120,   123,   124,   125,   126,   127,   128,
     121,   122,   193,     0,     0,   184,   187,     0,     0,     0,
     257,   199,    14,     0,   212,     0,   210,   215,   242,   242,
     242,     0,   208,   221,   208,   222,   208,   223,     0,     0,
      14,   255,   254,   256,     0,    14,   150,   242,   242,   154,
     152,   158,     0,     0,   145,   144,    18,   192,   190,    47,
      63,    64,    40,   177,   178,     0,     0,    68,    70,     0,
     197,   198,   186,   196,   195,   188,    14,     0,   214,   145,
       0,   209,     0,   206,   216,   227,   233,   237,   242,     0,
       0,     0,     0,   257,     0,     0,   153,   257,   257,   242,
       0,   159,   161,   242,   174,   242,     0,   183,    76,     0,
     202,   203,   201,     0,   211,   218,     0,   224,   225,   226,
       0,     0,   175,     0,     0,    14,   165,   166,     0,    14,
     257,   157,   242,   162,   160,   257,   257,   147,   200,   213,
       0,   220,   205,   207,   231,     0,   229,   235,     0,   241,
       0,   239,   257,     0,   257,   156,     0,   257,    14,    14,
     217,     0,   145,     0,   175,     0,    14,   167,    14,   257,
      14,     0,     0,   219,     0,   228,   230,   234,   236,   238,
     240,     0,   155,    14,   164,   172,   173,     0,   168,   163,
     232
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    36,    37,    38,    39,    95,    96,    97,    98,    41,
     131,    80,    43,    44,    45,    46,    47,   115,   116,    48,
     106,   107,   117,    49,    50,    51,   109,   110,   140,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    93,
      62,   209,   376,   210,    63,    64,   203,   204,   319,   320,
      65,   370,   371,   372,   404,    66,    67,    68,    69,   121,
     334,   122,   229,   230,   186,   187,    70,    71,    99,    72,
      73,   188,   189,   291,   382,    74,   413,    75,    76,   191,
     295,   296,   353,   354,   301,   302,   303,   415,   416,   304,
     305,   418,   306,   307,   420,   421,    86,    77,   129,   130,
     200,   201
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -332
static const yytype_int16 yypact[] =
{
     484,  -332,   955,   955,   955,   955,   955,  -332,  -332,  -332,
    -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,   817,  -332,
    -332,  -332,   987,   555,   413,   -40,    42,  -332,    16,   -53,
    -332,  -332,    26,  -332,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,   -12,  1051,  -332,  -332,    44,  1114,  1147,  -332,
    -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,   -30,
    -332,  -332,    -7,  -332,   -36,     9,  -332,  -332,   413,    10,
    -332,    73,    73,    73,    73,    73,  1023,   987,    72,   987,
     987,    72,    72,    40,    40,    14,  -332,    72,  -332,    72,
    -332,  -332,     6,  -332,    33,  -332,    36,    50,  -332,  -332,
      93,  -332,    91,    92,  -332,    96,   103,  -332,   -19,  -332,
    -332,     5,   886,  -332,  -332,  -332,  -332,  -332,  -332,   748,
    -332,    26,  -332,  -332,  -332,  -332,  -332,   226,  -332,   568,
     -25,   955,   955,   955,   955,   955,   955,   955,   955,   955,
     955,   955,   955,   955,   955,   955,   955,   955,   955,   955,
     955,   955,   955,   955,   955,   955,   987,   987,   987,   987,
     987,   987,   987,   987,   987,   987,   987,   987,   987,   987,
     987,  -332,   101,   102,   -27,    19,   197,   113,    34,  -332,
      -6,    40,   -14,   987,   756,   201,    72,  -332,  -332,  -332,
      88,   817,    72,   153,    76,    72,   817,   817,   205,    40,
    -332,    40,  -332,   679,  -332,    13,   128,  -332,  -332,  -332,
     626,   626,  -332,  -332,  -332,   626,  -332,  -332,  -332,   112,
     124,  -332,  -332,  -332,  -332,  -332,  -332,   -51,  -332,   -47,
    -332,   987,    39,    39,    73,    73,    73,    73,    73,    73,
      39,    39,  -332,  -332,  1051,  -332,  -332,   141,   825,   392,
     558,   118,   118,   118,   118,   118,   118,  -332,  -332,  -332,
    -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,  -332,    40,    40,  -332,  -332,   -38,     7,    40,
      72,  -332,   817,    40,   214,   -50,  -332,   190,  -332,  -332,
    -332,   131,   -36,  -332,   -36,  -332,   -36,  -332,  1167,   987,
     817,  -332,  -332,  -332,   163,   817,  -332,  -332,  -332,  -332,
    -332,   160,   155,   -11,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,  -332,  -332,  -332,    40,   626,  -332,  -332,   125,
    -332,  -332,  -332,  -332,  -332,  -332,   817,   -17,  -332,  -332,
      -6,  -332,    40,  -332,   199,  -332,  -332,  -332,   -14,   136,
     137,   142,   987,    72,   182,   987,  -332,    72,    72,  -332,
     183,    95,  -332,  -332,  -332,  -332,   987,  -332,  -332,   -17,
    -332,  -332,  -332,   987,  -332,   144,    40,  -332,  -332,  -332,
     184,    40,  -332,    40,   139,   817,  -332,  -332,   987,   817,
      72,  -332,  -332,  -332,  -332,    72,    72,  -332,  -332,  -332,
      40,   146,  -332,  -332,   238,   151,  -332,  -332,   154,  -332,
     156,  -332,    72,   192,    72,  -332,   987,    72,   817,   817,
    -332,    40,  -332,   130,   198,   134,   817,  -332,   817,    72,
     817,   200,   202,  -332,   987,  -332,  -332,  -332,  -332,  -332,
    -332,   207,  -332,   817,  -332,  -332,  -332,   164,  -332,  -332,
    -332
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -332,  -332,  -332,  -332,  -332,  -180,  -332,  -332,    38,  -332,
    -332,     0,  -332,  -332,   -34,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,   -26,  -332,  -332,  -332,  -218,   -29,  -332,  -332,
     374,  -332,  -332,  -332,   532,   -82,  -332,   -23,  -332,   234,
    -332,   167,  -331,  -119,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,  -332,  -332,  -109,  -332,  -332,  -332,  -332,  -332,  -332,
    -332,    75,  -332,  -332,  -332,    80,  -332,  -332,  -332,  -332,
     -28,  -332,   -22,  -332,  -114,  -332,  -332,  -332,  -332,  -189,
    -332,   -83,  -332,  -332,  -332,  -332,   -90,  -332,  -164,  -332,
     -86,  -332,  -332,   -80,  -332,  -159,    -1,   243,  -332,  -332,
      29,    41
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -259
static const yytype_int16 yytable[] =
{
      42,   100,   228,   330,   195,   118,   227,   108,   132,   102,
     111,   111,    87,    88,    89,    90,    -8,     1,   383,    91,
      92,   314,  -187,   293,     9,   240,   322,   323,    42,   101,
     133,   134,   135,   136,   119,   380,   127,   128,    40,   336,
     350,   374,   123,   336,     9,     9,   143,   144,   153,   337,
     351,   338,   289,   120,   181,   111,     9,   190,     9,   342,
     375,   298,   299,   300,   196,   381,   202,   205,   241,   226,
     285,   221,   185,   182,   183,   145,   146,   147,   148,    10,
      11,   137,   138,   139,   119,   151,   152,   182,   183,   184,
     325,     9,   325,   208,   208,  -258,   212,   235,   124,    27,
     192,   444,   311,   312,   313,  -180,   217,   125,   237,  -187,
     239,   308,   347,   359,   111,   360,   111,   361,   330,   151,
     152,   208,    42,   197,   198,   199,   213,   120,   215,    42,
     364,   218,   206,   207,   219,   366,   317,   318,   214,   220,
     216,   154,   155,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   369,   402,
     231,   197,   198,   199,   154,   155,   379,   234,   158,   159,
     102,   160,   161,   162,   163,   164,   165,   311,   312,   313,
     282,     9,   445,   221,   286,     9,   449,   327,   222,   223,
     294,   297,   225,   224,   329,   283,   284,   111,   331,   332,
     288,    42,   111,   289,   309,   316,    42,    42,   324,   208,
     328,   208,   333,    42,   335,   423,   377,   349,   339,   425,
     352,   365,   358,   369,   373,   378,   386,   391,   392,   292,
     103,     2,     3,   393,   396,   401,   412,   310,   410,   422,
     431,   432,   433,   315,   437,   434,   321,   435,   441,   442,
     447,   326,   455,   460,   456,     4,   451,    94,   452,   458,
     454,   211,   403,   290,   287,   408,   344,   384,   387,   446,
       5,     6,   388,   459,     7,     8,   450,     9,   389,    10,
      11,   126,     0,   340,   341,     0,   363,     0,   343,   345,
       0,     0,    42,   348,     0,     0,     0,   355,   356,   357,
       0,     0,     0,     0,    24,    25,     0,     0,     0,     0,
      42,     0,     0,   331,     0,    42,   367,   368,     0,    32,
       0,    33,    34,     0,     0,    35,   236,     0,     0,     0,
       0,   346,     0,     0,     0,   208,     0,     0,     0,   394,
       0,     0,   397,     0,     0,     0,    42,     0,     0,     0,
     294,     0,   385,   407,     0,     0,     0,   390,     0,     0,
     409,     0,     0,     0,   417,     0,     0,     0,   400,     0,
       0,     0,   405,     0,   406,   424,    81,    82,    83,    84,
      85,     0,     0,     0,     0,     0,   411,     0,     0,     0,
       0,   414,     0,   419,     0,    42,     0,     0,     0,    42,
       0,   427,     0,   439,   395,     0,   448,     0,   398,   399,
     430,     0,     0,     0,     0,   154,   155,   103,     2,     3,
       0,   457,   160,   161,   162,   163,   164,   165,    42,    42,
       0,   443,     0,   414,     0,   419,    42,     0,    42,     0,
      42,   426,     4,     0,     0,     0,   428,   429,     0,     0,
       0,     0,     0,    42,     0,     0,     0,     5,     6,     0,
       0,     7,     8,   436,     9,   438,    10,    11,   440,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     453,     0,     0,     0,     0,     1,     0,     0,     0,     2,
       3,    24,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   112,   113,     0,     0,    32,     0,    33,    34,
     114,     0,    35,     4,     0,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,     5,     6,
       0,     0,     7,     8,     0,     9,     0,    10,    11,    12,
      13,    14,     0,    15,     0,     0,    16,     0,     0,    17,
      18,    19,    20,     0,    21,     0,    22,    23,     0,   103,
       2,     3,    24,    25,     0,     0,    26,    27,  -175,    28,
      29,    30,   103,     2,     3,    31,     0,    32,     0,    33,
      34,   154,   155,    35,     4,   158,     0,     0,   160,   161,
     162,   163,   164,   165,     0,     0,     0,     4,     0,     5,
       6,     0,     0,     7,     8,     0,     9,     0,    10,    11,
       0,     0,     5,     6,     0,     0,     7,     8,   194,     9,
       0,    10,    11,     0,     0,     0,     0,     0,     0,     0,
     103,     2,     3,    24,    25,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,     0,    24,    25,    32,     0,
      33,    34,     0,   105,    35,     4,     0,     0,     0,     0,
       0,    32,     0,    33,    34,     0,   238,    35,     0,     0,
       5,     6,     0,     0,     7,     8,     0,     9,     0,    10,
      11,     0,     0,     0,     2,     3,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,     0,     0,
       0,     0,     0,     0,    24,    25,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    32,
       0,    33,    34,     5,     6,    35,     0,     7,     8,     0,
       9,     0,    10,    11,    12,    13,    14,     0,    15,     0,
       0,    16,     0,     0,    17,    18,    19,    20,     0,    21,
       0,    22,    23,     2,     3,     0,     0,    24,    25,     0,
       0,     0,     0,  -175,    28,     0,    30,     0,   311,   312,
     313,     0,    32,     0,    33,    34,     0,     4,    35,   154,
     155,   156,   157,   158,   159,     0,   160,   161,   162,   163,
     164,   165,     5,     6,     0,     0,     7,     8,     0,     9,
       0,    10,    11,    12,    13,    14,     0,    15,     0,     0,
      16,     0,     0,    17,    18,    19,    20,     0,    21,     0,
      22,    23,     2,     3,     0,     0,    24,    25,     0,     0,
       0,     0,  -175,    28,     0,    30,     0,   232,   233,     0,
       0,    32,     0,    33,    34,     0,     4,    35,   154,   155,
     156,     0,   158,   159,     0,   160,   161,   162,   163,   164,
     165,     5,     6,     0,     0,     7,     8,     0,     9,     0,
      10,    11,    12,    13,    14,     0,    15,     0,     0,    16,
       0,     0,    17,    18,    19,    20,     0,    21,     0,    22,
      23,     2,     3,     0,     0,    24,    25,     0,     0,     0,
       0,  -175,    28,     0,    30,     0,     0,     0,     0,     0,
      32,     0,    33,    34,     0,     4,    35,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     6,     0,     0,     7,     8,     0,     9,     0,    10,
      11,    12,    13,    14,     0,    15,     0,     0,    16,     0,
       0,    17,    18,    19,    20,     0,    21,     0,    22,    23,
       2,     3,     0,     0,    24,    25,     0,     0,     0,     0,
       0,    28,     0,    30,     0,     0,     0,     0,     0,    32,
       0,    33,    34,     0,     4,    35,     0,     0,     0,     0,
       0,     0,     2,     3,     0,     0,     0,     0,     0,     5,
       6,     0,     0,     7,     8,     0,     9,     0,    10,    11,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     3,
       0,     5,     6,    24,    25,     7,     8,     0,     9,     0,
      10,    11,     0,     0,     0,     0,     0,     0,    32,     0,
      33,    78,     4,     0,    79,     0,   141,   142,   143,   144,
       0,     0,     0,     0,     0,    24,    25,     5,     6,     0,
       0,     7,     8,     0,     9,     0,    10,    11,     0,     0,
      32,     0,    33,    34,     0,     0,    35,   145,   146,   147,
     148,   149,   150,     0,     0,     0,     0,   151,   152,     0,
       0,    24,    25,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,  -112,    33,    34,
       0,     0,    79,  -112,  -112,  -112,  -112,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,  -112,  -112,  -112,   154,   155,   156,
     157,   158,   159,     0,   160,   161,   162,   163,   164,   165,
     166,     0,     0,     0,     0,     0,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     362,     0,     0,     0,     0,     0,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180
};

static const yytype_int16 yycheck[] =
{
       0,    29,   121,   221,    86,    34,     1,    33,    42,    32,
      33,    34,    13,    14,    15,    16,     0,     1,   349,    20,
      21,   201,     3,    29,    51,    50,   206,   207,    28,    30,
      42,    43,    44,    45,    74,    52,    89,    90,     0,    90,
      90,    52,     0,    90,    51,    51,     7,     8,     4,   100,
     100,    98,    90,    93,    84,    78,    51,    93,    51,    97,
      71,    75,    76,    77,    87,    82,    89,    90,    93,    88,
      97,    90,    72,    80,    81,    36,    37,    38,    39,    53,
      54,    93,    94,    95,    74,    46,    47,    80,    81,    96,
     209,    51,   211,    93,    94,    82,    82,   131,    82,    83,
      91,   432,    89,    90,    91,   100,   100,    91,   137,    90,
     139,   193,   292,   302,   137,   304,   139,   306,   336,    46,
      47,   121,   122,    89,    90,    91,    97,    93,    99,   129,
     310,    98,    91,    92,    98,   315,    60,    61,    97,    89,
      99,    23,    24,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    63,    64,
     122,    89,    90,    91,    23,    24,   346,   129,    27,    28,
     193,    30,    31,    32,    33,    34,    35,    89,    90,    91,
     181,    51,    52,    90,   184,    51,    52,   215,    97,    97,
     190,   191,    89,    97,   220,    94,    94,   220,   221,   225,
       3,   201,   225,    90,     3,    52,   206,   207,     3,   209,
      82,   211,   100,   213,    90,   395,   335,     3,   241,   399,
      30,    58,    91,    63,    69,   100,    27,    91,    91,   188,
       4,     5,     6,    91,    52,    52,    52,   196,    94,   100,
      94,     3,    91,   202,    52,    91,   205,    91,   428,   429,
      52,   213,    52,    89,    52,    29,   436,    23,   438,    52,
     440,    94,   371,   188,   184,   379,   288,   350,   358,   433,
      44,    45,   358,   453,    48,    49,   435,    51,   358,    53,
      54,    38,    -1,   283,   284,    -1,   309,    -1,   288,   289,
      -1,    -1,   292,   293,    -1,    -1,    -1,   298,   299,   300,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   336,    -1,   315,   317,   318,    -1,    93,
      -1,    95,    96,    -1,    -1,    99,   100,    -1,    -1,    -1,
      -1,   290,    -1,    -1,    -1,   335,    -1,    -1,    -1,   362,
      -1,    -1,   365,    -1,    -1,    -1,   346,    -1,    -1,    -1,
     350,    -1,   352,   376,    -1,    -1,    -1,   358,    -1,    -1,
     383,    -1,    -1,    -1,   392,    -1,    -1,    -1,   369,    -1,
      -1,    -1,   373,    -1,   375,   398,     2,     3,     4,     5,
       6,    -1,    -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,
      -1,   391,    -1,   393,    -1,   395,    -1,    -1,    -1,   399,
      -1,   402,    -1,   426,   363,    -1,   434,    -1,   367,   368,
     410,    -1,    -1,    -1,    -1,    23,    24,     4,     5,     6,
      -1,   444,    30,    31,    32,    33,    34,    35,   428,   429,
      -1,   431,    -1,   433,    -1,   435,   436,    -1,   438,    -1,
     440,   400,    29,    -1,    -1,    -1,   405,   406,    -1,    -1,
      -1,    -1,    -1,   453,    -1,    -1,    -1,    44,    45,    -1,
      -1,    48,    49,   422,    51,   424,    53,    54,   427,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     439,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,     5,
       6,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    -1,    -1,    93,    -1,    95,    96,
      97,    -1,    99,    29,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,    44,    45,
      -1,    -1,    48,    49,    -1,    51,    -1,    53,    54,    55,
      56,    57,    -1,    59,    -1,    -1,    62,    -1,    -1,    65,
      66,    67,    68,    -1,    70,    -1,    72,    73,    -1,     4,
       5,     6,    78,    79,    -1,    -1,    82,    83,    84,    85,
      86,    87,     4,     5,     6,    91,    -1,    93,    -1,    95,
      96,    23,    24,    99,    29,    27,    -1,    -1,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    29,    -1,    44,
      45,    -1,    -1,    48,    49,    -1,    51,    -1,    53,    54,
      -1,    -1,    44,    45,    -1,    -1,    48,    49,    86,    51,
      -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       4,     5,     6,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    -1,    78,    79,    93,    -1,
      95,    96,    -1,    98,    99,    29,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    95,    96,    -1,    98,    99,    -1,    -1,
      44,    45,    -1,    -1,    48,    49,    -1,    51,    -1,    53,
      54,    -1,    -1,    -1,     5,     6,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    79,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    96,    44,    45,    99,    -1,    48,    49,    -1,
      51,    -1,    53,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    -1,    -1,    65,    66,    67,    68,    -1,    70,
      -1,    72,    73,     5,     6,    -1,    -1,    78,    79,    -1,
      -1,    -1,    -1,    84,    85,    -1,    87,    -1,    89,    90,
      91,    -1,    93,    -1,    95,    96,    -1,    29,    99,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    44,    45,    -1,    -1,    48,    49,    -1,    51,
      -1,    53,    54,    55,    56,    57,    -1,    59,    -1,    -1,
      62,    -1,    -1,    65,    66,    67,    68,    -1,    70,    -1,
      72,    73,     5,     6,    -1,    -1,    78,    79,    -1,    -1,
      -1,    -1,    84,    85,    -1,    87,    -1,    89,    90,    -1,
      -1,    93,    -1,    95,    96,    -1,    29,    99,    23,    24,
      25,    -1,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    44,    45,    -1,    -1,    48,    49,    -1,    51,    -1,
      53,    54,    55,    56,    57,    -1,    59,    -1,    -1,    62,
      -1,    -1,    65,    66,    67,    68,    -1,    70,    -1,    72,
      73,     5,     6,    -1,    -1,    78,    79,    -1,    -1,    -1,
      -1,    84,    85,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    95,    96,    -1,    29,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    45,    -1,    -1,    48,    49,    -1,    51,    -1,    53,
      54,    55,    56,    57,    -1,    59,    -1,    -1,    62,    -1,
      -1,    65,    66,    67,    68,    -1,    70,    -1,    72,    73,
       5,     6,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,
      -1,    85,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    96,    -1,    29,    99,    -1,    -1,    -1,    -1,
      -1,    -1,     5,     6,    -1,    -1,    -1,    -1,    -1,    44,
      45,    -1,    -1,    48,    49,    -1,    51,    -1,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,
      -1,    44,    45,    78,    79,    48,    49,    -1,    51,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      95,    96,    29,    -1,    99,    -1,     5,     6,     7,     8,
      -1,    -1,    -1,    -1,    -1,    78,    79,    44,    45,    -1,
      -1,    48,    49,    -1,    51,    -1,    53,    54,    -1,    -1,
      93,    -1,    95,    96,    -1,    -1,    99,    36,    37,    38,
      39,    40,    41,    -1,    -1,    -1,    -1,    46,    47,    -1,
      -1,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,     3,    95,    96,
      -1,    -1,    99,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
       3,    -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
       3,    -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     5,     6,    29,    44,    45,    48,    49,    51,
      53,    54,    55,    56,    57,    59,    62,    65,    66,    67,
      68,    70,    72,    73,    78,    79,    82,    83,    85,    86,
      87,    91,    93,    95,    96,    99,   102,   103,   104,   105,
     109,   110,   112,   113,   114,   115,   116,   117,   120,   124,
     125,   126,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   141,   145,   146,   151,   156,   157,   158,   159,
     167,   168,   170,   171,   176,   178,   179,   198,    96,    99,
     112,   131,   131,   131,   131,   131,   197,   197,   197,   197,
     197,   197,   197,   140,   140,   106,   107,   108,   109,   169,
     171,   197,   138,     4,    89,    98,   121,   122,   123,   127,
     128,   138,    89,    90,    97,   118,   119,   123,   128,    74,
      93,   160,   162,     0,    82,    91,   198,    89,    90,   199,
     200,   111,   115,    42,    43,    44,    45,    93,    94,    95,
     129,     5,     6,     7,     8,    36,    37,    38,    39,    40,
      41,    46,    47,     4,    23,    24,    25,    26,    27,    28,
      30,    31,    32,    33,    34,    35,     3,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    84,    80,    81,    96,   112,   165,   166,   172,   173,
      93,   180,    91,    93,   135,   136,   138,    89,    90,    91,
     201,   202,   138,   147,   148,   138,   202,   202,   112,   142,
     144,   142,    82,   201,   202,   201,   202,   100,    98,    98,
      89,    90,    97,    97,    97,    89,    88,     1,   144,   163,
     164,   109,    89,    90,   109,   115,   100,   128,    98,   128,
      50,    93,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   197,    94,    94,    97,   112,   166,     3,    90,
     162,   174,   202,    29,   112,   181,   182,   112,    75,    76,
      77,   185,   186,   187,   190,   191,   193,   194,   136,     3,
     202,    89,    90,    91,   106,   202,    52,    60,    61,   149,
     150,   202,   106,   106,     3,   144,   109,   171,    82,   123,
     127,   138,   123,   100,   161,    90,    90,   100,    98,   138,
     112,   112,    97,   112,   173,   112,   202,   106,   112,     3,
      90,   100,    30,   183,   184,   197,   197,   197,    91,   180,
     180,   180,     3,   138,   106,    58,   106,   197,   197,    63,
     152,   153,   154,    69,    52,    71,   143,   144,   100,   106,
      52,    82,   175,   143,   182,   112,    27,   187,   191,   194,
     197,    91,    91,    91,   138,   202,    52,   138,   202,   202,
     197,    52,    64,   154,   155,   197,   197,   138,   175,   138,
      94,   112,    52,   177,   112,   188,   189,   171,   192,   112,
     195,   196,   100,   106,   138,   106,   202,   197,   202,   202,
     112,    94,     3,    91,    91,    91,   202,    52,   202,   138,
     202,   106,   106,   112,   143,    52,   189,    52,   171,    52,
     196,   106,   106,   202,   106,    52,    52,   138,    52,   106,
      89
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 532 "parse.y"
    {
		    global_command = (yyvsp[(1) - (1)].tree_statement_list_type);
		    promptflag = 1;
		    YYACCEPT;
		  }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 538 "parse.y"
    {
		    YYACCEPT;
		  }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 542 "parse.y"
    { ABORT_PARSE; }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 544 "parse.y"
    { ABORT_PARSE; }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 548 "parse.y"
    { (yyval.tree_statement_list_type) = 0; }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 550 "parse.y"
    {
		    parser_end_of_input = 1;
		    (yyval.tree_statement_list_type) = 0;
		  }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 555 "parse.y"
    { (yyval.tree_statement_list_type) = (yyvsp[(1) - (1)].tree_statement_list_type); }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 557 "parse.y"
    { (yyval.tree_statement_list_type) = (yyvsp[(1) - (2)].tree_statement_list_type); }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 559 "parse.y"
    { (yyval.tree_statement_list_type) = (yyvsp[(1) - (2)].tree_statement_list_type); }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 563 "parse.y"
    { (yyval.tree_statement_list_type) = set_stmt_print_flag ((yyvsp[(1) - (2)].tree_statement_list_type), (yyvsp[(2) - (2)].sep_type), false); }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 567 "parse.y"
    { (yyval.tree_statement_list_type) = make_statement_list ((yyvsp[(1) - (1)].tree_statement_type)); }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 569 "parse.y"
    { (yyval.tree_statement_list_type) = append_statement_list ((yyvsp[(1) - (3)].tree_statement_list_type), (yyvsp[(2) - (3)].sep_type), (yyvsp[(3) - (3)].tree_statement_type), false); }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 573 "parse.y"
    { (yyval.tree_statement_list_type) = new tree_statement_list (); }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 575 "parse.y"
    { (yyval.tree_statement_list_type) = (yyvsp[(1) - (1)].tree_statement_list_type); }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 579 "parse.y"
    { (yyval.tree_statement_list_type) = set_stmt_print_flag ((yyvsp[(1) - (2)].tree_statement_list_type), (yyvsp[(2) - (2)].sep_type), true); }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 583 "parse.y"
    { (yyval.tree_statement_list_type) = make_statement_list ((yyvsp[(1) - (1)].tree_statement_type)); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 585 "parse.y"
    { (yyval.tree_statement_list_type) = append_statement_list ((yyvsp[(1) - (3)].tree_statement_list_type), (yyvsp[(2) - (3)].sep_type), (yyvsp[(3) - (3)].tree_statement_type), true); }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 589 "parse.y"
    { (yyval.tree_statement_type) = make_statement ((yyvsp[(1) - (1)].tree_expression_type)); }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 591 "parse.y"
    { (yyval.tree_statement_type) = make_statement ((yyvsp[(1) - (1)].tree_command_type)); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 593 "parse.y"
    { (yyval.tree_statement_type) = make_statement ((yyvsp[(1) - (1)].tree_index_expression_type)); }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 605 "parse.y"
    { (yyval.tree_index_expression_type) = make_index_expression ((yyvsp[(1) - (2)].tree_identifier_type), (yyvsp[(2) - (2)].tree_argument_list_type), '('); }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 609 "parse.y"
    { (yyval.tree_argument_list_type) = new tree_argument_list ((yyvsp[(1) - (1)].tree_constant_type)); }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 611 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_argument_list_type)->append ((yyvsp[(2) - (2)].tree_constant_type));
		    (yyval.tree_argument_list_type) = (yyvsp[(1) - (2)].tree_argument_list_type);
		  }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 622 "parse.y"
    {
		    symbol_table::symbol_record *sr = (yyvsp[(1) - (1)].tok_val)->sym_rec ();
		    (yyval.tree_identifier_type) = new tree_identifier (*sr, (yyvsp[(1) - (1)].tok_val)->line (), (yyvsp[(1) - (1)].tok_val)->column ());
		  }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 630 "parse.y"
    { (yyval.tree_identifier_type) = new tree_identifier ((yyvsp[(1) - (1)].tok_val)->line (), (yyvsp[(1) - (1)].tok_val)->column ()); }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 634 "parse.y"
    { (yyval.tree_identifier_type) = new tree_identifier ((yyvsp[(1) - (1)].tok_val)->line (), (yyvsp[(1) - (1)].tok_val)->column ()); }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 638 "parse.y"
    { (yyval.tree_constant_type) = make_constant (DQ_STRING, (yyvsp[(1) - (1)].tok_val)); }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 640 "parse.y"
    { (yyval.tree_constant_type) = make_constant (SQ_STRING, (yyvsp[(1) - (1)].tok_val)); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 644 "parse.y"
    { (yyval.tree_constant_type) = make_constant (NUM, (yyvsp[(1) - (1)].tok_val)); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 646 "parse.y"
    { (yyval.tree_constant_type) = make_constant (IMAG_NUM, (yyvsp[(1) - (1)].tok_val)); }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 648 "parse.y"
    { (yyval.tree_constant_type) = (yyvsp[(1) - (1)].tree_constant_type); }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 652 "parse.y"
    {
		    (yyval.tree_expression_type) = new tree_constant (octave_null_matrix::instance);
		    lexer_flags.looking_at_matrix_or_assign_lhs = false;
		    lexer_flags.pending_local_variables.clear ();
		  }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 658 "parse.y"
    {
		    (yyval.tree_expression_type) = new tree_constant (octave_null_matrix::instance);
		    lexer_flags.looking_at_matrix_or_assign_lhs = false;
		    lexer_flags.pending_local_variables.clear ();
		  }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 664 "parse.y"
    {
		    (yyval.tree_expression_type) = new tree_constant (octave_null_matrix::instance);
		    lexer_flags.looking_at_matrix_or_assign_lhs = false;
		    lexer_flags.pending_local_variables.clear ();
		  }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 670 "parse.y"
    {
		    (yyval.tree_expression_type) = finish_matrix ((yyvsp[(2) - (3)].tree_matrix_type));
		    lexer_flags.looking_at_matrix_or_assign_lhs = false;
		    lexer_flags.pending_local_variables.clear ();
		  }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 678 "parse.y"
    { (yyval.tree_matrix_type) = (yyvsp[(1) - (1)].tree_matrix_type); }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 680 "parse.y"
    { (yyval.tree_matrix_type) = (yyvsp[(1) - (2)].tree_matrix_type); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 684 "parse.y"
    { (yyval.tree_matrix_type) = new tree_matrix ((yyvsp[(1) - (1)].tree_argument_list_type)); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 686 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_matrix_type)->append ((yyvsp[(3) - (3)].tree_argument_list_type));
		    (yyval.tree_matrix_type) = (yyvsp[(1) - (3)].tree_matrix_type);
		  }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 693 "parse.y"
    { (yyval.tree_expression_type) = new tree_constant (octave_value (Cell ())); }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 695 "parse.y"
    { (yyval.tree_expression_type) = new tree_constant (octave_value (Cell ())); }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 697 "parse.y"
    { (yyval.tree_expression_type) = finish_cell ((yyvsp[(2) - (3)].tree_cell_type)); }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 701 "parse.y"
    { (yyval.tree_cell_type) = (yyvsp[(1) - (1)].tree_cell_type); }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 703 "parse.y"
    { (yyval.tree_cell_type) = (yyvsp[(1) - (2)].tree_cell_type); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 707 "parse.y"
    { (yyval.tree_cell_type) = new tree_cell ((yyvsp[(1) - (1)].tree_argument_list_type)); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 709 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_cell_type)->append ((yyvsp[(3) - (3)].tree_argument_list_type));
		    (yyval.tree_cell_type) = (yyvsp[(1) - (3)].tree_cell_type);
		  }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 717 "parse.y"
    { (yyval.tree_argument_list_type) = (yyvsp[(1) - (1)].tree_argument_list_type); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 719 "parse.y"
    { (yyval.tree_argument_list_type) = (yyvsp[(1) - (2)].tree_argument_list_type); }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 723 "parse.y"
    {
		    (yyval.tree_fcn_handle_type) = make_fcn_handle ((yyvsp[(2) - (2)].tok_val));
		    lexer_flags.looking_at_function_handle--;
		  }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 730 "parse.y"
    { (yyval.tree_anon_fcn_handle_type) = make_anon_fcn_handle ((yyvsp[(2) - (3)].tree_parameter_list_type), (yyvsp[(3) - (3)].tree_statement_type)); }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 734 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_identifier_type); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 736 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_constant_type); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 738 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_fcn_handle_type); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 740 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 742 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 744 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_identifier_type); }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 746 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_identifier_type); }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 748 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(2) - (3)].tree_expression_type)->mark_in_parens (); }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 752 "parse.y"
    {
		    octave_value tmp (octave_value::magic_colon_t);
		    (yyval.tree_constant_type) = new tree_constant (tmp);
		  }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 759 "parse.y"
    { (yyval.tree_argument_list_type) = new tree_argument_list ((yyvsp[(1) - (1)].tree_expression_type)); }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 761 "parse.y"
    { (yyval.tree_argument_list_type) = new tree_argument_list ((yyvsp[(1) - (1)].tree_constant_type)); }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 763 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_argument_list_type)->append ((yyvsp[(3) - (3)].tree_constant_type));
		    (yyval.tree_argument_list_type) = (yyvsp[(1) - (3)].tree_argument_list_type);
		  }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 768 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_argument_list_type)->append ((yyvsp[(3) - (3)].tree_expression_type));
		    (yyval.tree_argument_list_type) = (yyvsp[(1) - (3)].tree_argument_list_type);
		  }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 775 "parse.y"
    { lexer_flags.looking_at_indirect_ref = true; }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 779 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 781 "parse.y"
    { (yyval.tree_expression_type) = make_index_expression ((yyvsp[(1) - (3)].tree_expression_type), 0, '('); }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 783 "parse.y"
    { (yyval.tree_expression_type) = make_index_expression ((yyvsp[(1) - (4)].tree_expression_type), (yyvsp[(3) - (4)].tree_argument_list_type), '('); }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 785 "parse.y"
    { (yyval.tree_expression_type) = make_index_expression ((yyvsp[(1) - (3)].tree_expression_type), 0, '{'); }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 787 "parse.y"
    { (yyval.tree_expression_type) = make_index_expression ((yyvsp[(1) - (4)].tree_expression_type), (yyvsp[(3) - (4)].tree_argument_list_type), '{'); }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 789 "parse.y"
    { (yyval.tree_expression_type) = make_postfix_op (PLUS_PLUS, (yyvsp[(1) - (2)].tree_expression_type), (yyvsp[(2) - (2)].tok_val)); }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 791 "parse.y"
    { (yyval.tree_expression_type) = make_postfix_op (MINUS_MINUS, (yyvsp[(1) - (2)].tree_expression_type), (yyvsp[(2) - (2)].tok_val)); }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 793 "parse.y"
    { (yyval.tree_expression_type) = make_postfix_op (QUOTE, (yyvsp[(1) - (2)].tree_expression_type), (yyvsp[(2) - (2)].tok_val)); }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 795 "parse.y"
    { (yyval.tree_expression_type) = make_postfix_op (TRANSPOSE, (yyvsp[(1) - (2)].tree_expression_type), (yyvsp[(2) - (2)].tok_val)); }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 797 "parse.y"
    { (yyval.tree_expression_type) = make_indirect_ref ((yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(3) - (3)].tok_val)->text ()); }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 799 "parse.y"
    { (yyval.tree_expression_type) = make_indirect_ref ((yyvsp[(1) - (5)].tree_expression_type), (yyvsp[(4) - (5)].tree_expression_type)); }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 803 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 805 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 807 "parse.y"
    { (yyval.tree_expression_type) = make_prefix_op (PLUS_PLUS, (yyvsp[(2) - (2)].tree_expression_type), (yyvsp[(1) - (2)].tok_val)); }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 809 "parse.y"
    { (yyval.tree_expression_type) = make_prefix_op (MINUS_MINUS, (yyvsp[(2) - (2)].tree_expression_type), (yyvsp[(1) - (2)].tok_val)); }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 811 "parse.y"
    { (yyval.tree_expression_type) = make_prefix_op (EXPR_NOT, (yyvsp[(2) - (2)].tree_expression_type), (yyvsp[(1) - (2)].tok_val)); }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 813 "parse.y"
    { (yyval.tree_expression_type) = make_prefix_op ('+', (yyvsp[(2) - (2)].tree_expression_type), (yyvsp[(1) - (2)].tok_val)); }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 815 "parse.y"
    { (yyval.tree_expression_type) = make_prefix_op ('-', (yyvsp[(2) - (2)].tree_expression_type), (yyvsp[(1) - (2)].tok_val)); }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 819 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (POW, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 821 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EPOW, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 823 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('+', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 825 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('-', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 827 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('*', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 829 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('/', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 831 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('+', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 833 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op ('-', (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 835 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EMUL, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 837 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EDIV, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 839 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (LEFTDIV, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 841 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (ELEFTDIV, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 845 "parse.y"
    { (yyval.tree_expression_type) = finish_colon_expression ((yyvsp[(1) - (1)].tree_colon_expression_type)); }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 849 "parse.y"
    { (yyval.tree_colon_expression_type) = new tree_colon_expression ((yyvsp[(1) - (1)].tree_expression_type)); }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 851 "parse.y"
    {
		    if (! ((yyval.tree_colon_expression_type) = (yyvsp[(1) - (3)].tree_colon_expression_type)->append ((yyvsp[(3) - (3)].tree_expression_type))))
		      ABORT_PARSE;
		  }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 858 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 860 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (LSHIFT, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 862 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (RSHIFT, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 864 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_LT, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 866 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_LE, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 868 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_EQ, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 870 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_GE, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 872 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_GT, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 874 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_NE, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 876 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_AND, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 878 "parse.y"
    { (yyval.tree_expression_type) = make_binary_op (EXPR_OR, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 880 "parse.y"
    { (yyval.tree_expression_type) = make_boolean_op (EXPR_AND_AND, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 882 "parse.y"
    { (yyval.tree_expression_type) = make_boolean_op (EXPR_OR_OR, (yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 889 "parse.y"
    {
		    (yyval.tree_argument_list_type) = new tree_argument_list ((yyvsp[(1) - (1)].tree_expression_type));
		    (yyval.tree_argument_list_type)->mark_as_simple_assign_lhs ();
		  }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 894 "parse.y"
    {
		    (yyval.tree_argument_list_type) = (yyvsp[(2) - (3)].tree_argument_list_type);
		    lexer_flags.looking_at_matrix_or_assign_lhs = false;
		    for (std::set<std::string>::const_iterator p = lexer_flags.pending_local_variables.begin ();
			 p != lexer_flags.pending_local_variables.end ();
			 p++)
		      {
			symbol_table::force_variable (*p);
		      }
		    lexer_flags.pending_local_variables.clear ();
		  }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 908 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op ('=', (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 910 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (ADD_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 912 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (SUB_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 914 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (MUL_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 916 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (DIV_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 918 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (LEFTDIV_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 920 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (POW_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 922 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (LSHIFT_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 924 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (RSHIFT_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 926 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (EMUL_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 928 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (EDIV_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 930 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (ELEFTDIV_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 932 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (EPOW_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 934 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (AND_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 936 "parse.y"
    { (yyval.tree_expression_type) = make_assign_op (OR_EQ, (yyvsp[(1) - (3)].tree_argument_list_type), (yyvsp[(2) - (3)].tok_val), (yyvsp[(3) - (3)].tree_expression_type)); }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 940 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 942 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_expression_type); }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 944 "parse.y"
    { (yyval.tree_expression_type) = (yyvsp[(1) - (1)].tree_anon_fcn_handle_type); }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 952 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_decl_command_type); }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 954 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 956 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 958 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 960 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 962 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 964 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 966 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_command_type); }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 975 "parse.y"
    { lexer_flags.looking_at_decl_list = true; }
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 978 "parse.y"
    {
		    (yyval.tree_decl_command_type) = make_decl_command (GLOBAL, (yyvsp[(1) - (3)].tok_val), (yyvsp[(3) - (3)].tree_decl_init_list_type));
		    lexer_flags.looking_at_decl_list = false;
		  }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 983 "parse.y"
    {
		    (yyval.tree_decl_command_type) = make_decl_command (STATIC, (yyvsp[(1) - (3)].tok_val), (yyvsp[(3) - (3)].tree_decl_init_list_type));
		    lexer_flags.looking_at_decl_list = false;
		  }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 990 "parse.y"
    { (yyval.tree_decl_init_list_type) = new tree_decl_init_list ((yyvsp[(1) - (1)].tree_decl_elt_type)); }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 992 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_decl_init_list_type)->append ((yyvsp[(2) - (2)].tree_decl_elt_type));
		    (yyval.tree_decl_init_list_type) = (yyvsp[(1) - (2)].tree_decl_init_list_type);
		  }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 999 "parse.y"
    { lexer_flags.looking_at_initializer_expression = true; }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1002 "parse.y"
    { (yyval.tree_decl_elt_type) = new tree_decl_elt ((yyvsp[(1) - (1)].tree_identifier_type)); }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1004 "parse.y"
    {
		    lexer_flags.looking_at_initializer_expression = false;
		    (yyval.tree_decl_elt_type) = new tree_decl_elt ((yyvsp[(1) - (4)].tree_identifier_type), (yyvsp[(4) - (4)].tree_expression_type));
		  }
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1015 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_if_command_type); }
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1017 "parse.y"
    { (yyval.tree_command_type) = (yyvsp[(1) - (1)].tree_switch_command_type); }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1025 "parse.y"
    {
		    if (! ((yyval.tree_if_command_type) = finish_if_command ((yyvsp[(1) - (4)].tok_val), (yyvsp[(3) - (4)].tree_if_command_list_type), (yyvsp[(4) - (4)].tok_val), (yyvsp[(2) - (4)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1032 "parse.y"
    { (yyval.tree_if_command_list_type) = (yyvsp[(1) - (1)].tree_if_command_list_type); }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1034 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_if_command_list_type)->append ((yyvsp[(2) - (2)].tree_if_clause_type));
		    (yyval.tree_if_command_list_type) = (yyvsp[(1) - (2)].tree_if_command_list_type);
		  }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1041 "parse.y"
    { (yyval.tree_if_command_list_type) = start_if_command ((yyvsp[(1) - (3)].tree_expression_type), (yyvsp[(3) - (3)].tree_statement_list_type)); }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1043 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_if_command_list_type)->append ((yyvsp[(2) - (2)].tree_if_clause_type));
		    (yyval.tree_if_command_list_type) = (yyvsp[(1) - (2)].tree_if_command_list_type);
		  }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1050 "parse.y"
    { (yyval.tree_if_clause_type) = make_elseif_clause ((yyvsp[(1) - (6)].tok_val), (yyvsp[(4) - (6)].tree_expression_type), (yyvsp[(6) - (6)].tree_statement_list_type), (yyvsp[(2) - (6)].comment_type)); }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1054 "parse.y"
    { (yyval.tree_if_clause_type) = new tree_if_clause ((yyvsp[(4) - (4)].tree_statement_list_type), (yyvsp[(2) - (4)].comment_type)); }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1062 "parse.y"
    {
		    if (! ((yyval.tree_switch_command_type) = finish_switch_command ((yyvsp[(1) - (6)].tok_val), (yyvsp[(3) - (6)].tree_expression_type), (yyvsp[(5) - (6)].tree_switch_case_list_type), (yyvsp[(6) - (6)].tok_val), (yyvsp[(2) - (6)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1069 "parse.y"
    { (yyval.tree_switch_case_list_type) = new tree_switch_case_list (); }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1071 "parse.y"
    { (yyval.tree_switch_case_list_type) = (yyvsp[(1) - (1)].tree_switch_case_list_type); }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1073 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_switch_case_list_type)->append ((yyvsp[(2) - (2)].tree_switch_case_type));
		    (yyval.tree_switch_case_list_type) = (yyvsp[(1) - (2)].tree_switch_case_list_type);
		  }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1080 "parse.y"
    { (yyval.tree_switch_case_list_type) = new tree_switch_case_list ((yyvsp[(1) - (1)].tree_switch_case_type)); }
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1082 "parse.y"
    {
		    (yyvsp[(1) - (2)].tree_switch_case_list_type)->append ((yyvsp[(2) - (2)].tree_switch_case_type));
		    (yyval.tree_switch_case_list_type) = (yyvsp[(1) - (2)].tree_switch_case_list_type);
		  }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1089 "parse.y"
    { (yyval.tree_switch_case_type) = make_switch_case ((yyvsp[(1) - (6)].tok_val), (yyvsp[(4) - (6)].tree_expression_type), (yyvsp[(6) - (6)].tree_statement_list_type), (yyvsp[(2) - (6)].comment_type)); }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1093 "parse.y"
    {
		    (yyval.tree_switch_case_type) = new tree_switch_case ((yyvsp[(4) - (4)].tree_statement_list_type), (yyvsp[(2) - (4)].comment_type));
		  }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1103 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_while_command ((yyvsp[(1) - (6)].tok_val), (yyvsp[(3) - (6)].tree_expression_type), (yyvsp[(5) - (6)].tree_statement_list_type), (yyvsp[(6) - (6)].tok_val), (yyvsp[(2) - (6)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1108 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_do_until_command ((yyvsp[(5) - (6)].tok_val), (yyvsp[(4) - (6)].tree_statement_list_type), (yyvsp[(6) - (6)].tree_expression_type), (yyvsp[(2) - (6)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1113 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_for_command ((yyvsp[(1) - (8)].tok_val), (yyvsp[(3) - (8)].tree_argument_list_type), (yyvsp[(5) - (8)].tree_expression_type), (yyvsp[(7) - (8)].tree_statement_list_type), (yyvsp[(8) - (8)].tok_val), (yyvsp[(2) - (8)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1118 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_for_command ((yyvsp[(1) - (10)].tok_val), (yyvsp[(4) - (10)].tree_argument_list_type), (yyvsp[(6) - (10)].tree_expression_type), (yyvsp[(9) - (10)].tree_statement_list_type), (yyvsp[(10) - (10)].tok_val), (yyvsp[(2) - (10)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1129 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_break_command ((yyvsp[(1) - (1)].tok_val))))
		      ABORT_PARSE;
		  }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1134 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_continue_command ((yyvsp[(1) - (1)].tok_val))))
		      ABORT_PARSE;
		  }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1139 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_return_command ((yyvsp[(1) - (1)].tok_val))))
		      ABORT_PARSE;
		  }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1151 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_unwind_command ((yyvsp[(1) - (9)].tok_val), (yyvsp[(4) - (9)].tree_statement_list_type), (yyvsp[(8) - (9)].tree_statement_list_type), (yyvsp[(9) - (9)].tok_val), (yyvsp[(2) - (9)].comment_type), (yyvsp[(6) - (9)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1157 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_try_command ((yyvsp[(1) - (9)].tok_val), (yyvsp[(4) - (9)].tree_statement_list_type), (yyvsp[(8) - (9)].tree_statement_list_type), (yyvsp[(9) - (9)].tok_val), (yyvsp[(2) - (9)].comment_type), (yyvsp[(6) - (9)].comment_type))))
		      ABORT_PARSE;
		  }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1162 "parse.y"
    {
		    if (! ((yyval.tree_command_type) = make_try_command ((yyvsp[(1) - (5)].tok_val), (yyvsp[(4) - (5)].tree_statement_list_type), 0, (yyvsp[(5) - (5)].tok_val), (yyvsp[(2) - (5)].comment_type), 0)))
		      ABORT_PARSE;
		  }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1173 "parse.y"
    {
		    current_function_depth++;

		    if (max_function_depth < current_function_depth)
		      max_function_depth = current_function_depth;

		    symtab_context.push (symbol_table::current_scope ());
		    symbol_table::set_scope (symbol_table::alloc_scope ());

		    if (! reading_script_file && current_function_depth == 1
			&& ! parsing_subfunctions)
		      primary_fcn_scope = symbol_table::current_scope ();

		    if (reading_script_file && current_function_depth > 1)
		      yyerror ("nested functions not implemented in this context");
		  }
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1196 "parse.y"
    {
		    lexer_flags.looking_at_parameter_list = true;

		    if (lexer_flags.looking_at_function_handle)
		      {
		        symtab_context.push (symbol_table::current_scope ());
			symbol_table::set_scope (symbol_table::alloc_scope ());
			lexer_flags.looking_at_function_handle--;
		      }
		  }
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1209 "parse.y"
    {
		    lexer_flags.looking_at_parameter_list = false;
		    lexer_flags.looking_for_object_index = false;
		  }
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1216 "parse.y"
    {
		    lexer_flags.quote_is_transpose = false;
		    (yyval.tree_parameter_list_type) = (yyvsp[(2) - (3)].tree_parameter_list_type);
		  }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1221 "parse.y"
    {
		    yyerror ("invalid parameter list");
		    (yyval.tree_parameter_list_type) = 0;
		    ABORT_PARSE;
		  }
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1229 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1231 "parse.y"
    {
		    (yyvsp[(1) - (1)].tree_parameter_list_type)->mark_as_formal_parameters ();
		    if ((yyvsp[(1) - (1)].tree_parameter_list_type)->validate (tree_parameter_list::in))
		      (yyval.tree_parameter_list_type) = (yyvsp[(1) - (1)].tree_parameter_list_type);
		    else
		      ABORT_PARSE;
		  }
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1241 "parse.y"
    { (yyval.tree_parameter_list_type) = new tree_parameter_list ((yyvsp[(1) - (1)].tree_decl_elt_type)); }
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1243 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_parameter_list_type)->append ((yyvsp[(3) - (3)].tree_decl_elt_type));
		    (yyval.tree_parameter_list_type) = (yyvsp[(1) - (3)].tree_parameter_list_type);
		  }
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1254 "parse.y"
    {
		    lexer_flags.looking_at_return_list = false;
		    (yyval.tree_parameter_list_type) = new tree_parameter_list ();
		  }
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1259 "parse.y"
    {
		    lexer_flags.looking_at_return_list = false;
		    if ((yyvsp[(1) - (1)].tree_parameter_list_type)->validate (tree_parameter_list::out))
		      (yyval.tree_parameter_list_type) = (yyvsp[(1) - (1)].tree_parameter_list_type);
		    else
		      ABORT_PARSE;
		  }
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1267 "parse.y"
    {
		    lexer_flags.looking_at_return_list = false;
		    if ((yyvsp[(2) - (3)].tree_parameter_list_type)->validate (tree_parameter_list::out))
		      (yyval.tree_parameter_list_type) = (yyvsp[(2) - (3)].tree_parameter_list_type);
		    else
		      ABORT_PARSE;
		  }
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1277 "parse.y"
    { (yyval.tree_parameter_list_type) = new tree_parameter_list (new tree_decl_elt ((yyvsp[(1) - (1)].tree_identifier_type))); }
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1279 "parse.y"
    {
		    (yyvsp[(1) - (3)].tree_parameter_list_type)->append (new tree_decl_elt ((yyvsp[(3) - (3)].tree_identifier_type)));
		    (yyval.tree_parameter_list_type) = (yyvsp[(1) - (3)].tree_parameter_list_type);
		  }
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1290 "parse.y"
    {
		    tree_statement *end_of_script
		      = make_end ("endscript", input_line_number,
				  current_input_column);

		    make_script ((yyvsp[(2) - (3)].tree_statement_list_type), end_of_script);

		    (yyval.tree_command_type) = 0;
		  }
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1306 "parse.y"
    { (yyval.tree_command_type) = 0; }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1318 "parse.y"
    {
		    (yyval.comment_type) = (yyvsp[(3) - (3)].comment_type);

		    if (reading_classdef_file || lexer_flags.parsing_classdef) 
		      lexer_flags.maybe_classdef_get_set_method = true; 
		  }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1327 "parse.y"
    {
		    (yyval.tree_command_type) = finish_function (0, (yyvsp[(2) - (2)].octave_user_function_type), (yyvsp[(1) - (2)].comment_type));
		    recover_from_parsing_function ();
		  }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1332 "parse.y"
    {
		    (yyval.tree_command_type) = finish_function ((yyvsp[(2) - (4)].tree_parameter_list_type), (yyvsp[(4) - (4)].octave_user_function_type), (yyvsp[(1) - (4)].comment_type));
		    recover_from_parsing_function ();
		  }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1339 "parse.y"
    {
		    std::string id_name = (yyvsp[(1) - (1)].tree_identifier_type)->name ();

		    lexer_flags.parsed_function_name = true;
		    lexer_flags.defining_func = false;
		    lexer_flags.maybe_classdef_get_set_method = false;
            
		    (yyval.tree_identifier_type) = (yyvsp[(1) - (1)].tree_identifier_type);
		  }
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1349 "parse.y"
    {
		    lexer_flags.maybe_classdef_get_set_method = false;
		    (yyval.tree_identifier_type) = (yyvsp[(3) - (3)].tree_identifier_type);
		  }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1354 "parse.y"
    {
		    lexer_flags.maybe_classdef_get_set_method = false;
		    (yyval.tree_identifier_type) = (yyvsp[(3) - (3)].tree_identifier_type);
		  }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1361 "parse.y"
    {
		    std::string fname = (yyvsp[(1) - (2)].tree_identifier_type)->name ();

		    delete (yyvsp[(1) - (2)].tree_identifier_type);

		    if (! ((yyval.octave_user_function_type) = frob_function (fname, (yyvsp[(2) - (2)].octave_user_function_type))))
		      ABORT_PARSE;
		  }
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1372 "parse.y"
    { (yyval.octave_user_function_type) = start_function ((yyvsp[(1) - (4)].tree_parameter_list_type), (yyvsp[(3) - (4)].tree_statement_list_type), (yyvsp[(4) - (4)].tree_statement_type)); }
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1374 "parse.y"
    { (yyval.octave_user_function_type) = start_function (0, (yyvsp[(2) - (3)].tree_statement_list_type), (yyvsp[(3) - (3)].tree_statement_type)); }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1378 "parse.y"
    {
		    endfunction_found = true;
		    if (end_token_ok ((yyvsp[(1) - (1)].tok_val), token::function_end))
		      (yyval.tree_statement_type) = make_end ("endfunction", (yyvsp[(1) - (1)].tok_val)->line (), (yyvsp[(1) - (1)].tok_val)->column ());
		    else
		      ABORT_PARSE;
		  }
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1386 "parse.y"
    {
// A lot of tests are based on the assumption that this is OK
// 		    if (reading_script_file)
// 		      {
// 			yyerror ("function body open at end of script");
// 			YYABORT;
// 		      }

		    if (endfunction_found)
		      {
			yyerror ("inconsistent function endings -- "
				 "if one function is explicitly ended, "
				 "so must all the others");
			YYABORT;
		      }

		    if (! reading_fcn_file && ! reading_script_file)
		      {
			yyerror ("function body open at end of input");
			YYABORT;
		      }

		    if (reading_classdef_file)
		      {
		        yyerror ("classdef body open at end of input");
		        YYABORT;
		      }

		    (yyval.tree_statement_type) = make_end ("endfunction", input_line_number,
				   current_input_column);
		  }
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1424 "parse.y"
    {
		    (yyval.comment_type) = 0;
		    lexer_flags.parsing_classdef = true;
		  }
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1431 "parse.y"
    {
		    lexer_flags.parsing_classdef = false;

		    if (end_token_ok ((yyvsp[(1) - (1)].tok_val), token::classdef_end))
		      (yyval.tree_statement_type) = make_end ("endclassdef", (yyvsp[(1) - (1)].tok_val)->line (), (yyvsp[(1) - (1)].tok_val)->column ());
		    else
		      ABORT_PARSE;
		  }
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1442 "parse.y"
    { (yyval.octave_user_function_type) = 0; }
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1446 "parse.y"
    { (yyval.tree_command_type) = 0; }
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1450 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1452 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1456 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1458 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1462 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1464 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1466 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1471 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1473 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1477 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1479 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1481 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1483 "parse.y"
    { (yyval.tree_parameter_list_type) = 0; }
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1487 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1489 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1491 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1493 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1495 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1497 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1501 "parse.y"
    { (yyval.comment_type) = 0; }
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1506 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1511 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1513 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1517 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1519 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1523 "parse.y"
    { (yyval.comment_type) = 0; }
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1527 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1531 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1533 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1537 "parse.y"
    { (yyval.comment_type) = 0; }
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1541 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1545 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1547 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1551 "parse.y"
    { (yyval.dummy_type) = 0; }
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1559 "parse.y"
    { (yyval.comment_type) = octave_comment_buffer::get_comment (); }
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1563 "parse.y"
    { yyerror ("parse error"); }
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1568 "parse.y"
    { (yyval.sep_type) = ','; }
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1570 "parse.y"
    { (yyval.sep_type) = ';'; }
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1572 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (2)].sep_type); }
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1574 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (2)].sep_type); }
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1578 "parse.y"
    { (yyval.sep_type) = 0; }
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1580 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (1)].sep_type); }
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1584 "parse.y"
    { (yyval.sep_type) = ','; }
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1586 "parse.y"
    { (yyval.sep_type) = ';'; }
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1588 "parse.y"
    { (yyval.sep_type) = '\n'; }
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1590 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (2)].sep_type); }
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1592 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (2)].sep_type); }
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1594 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (2)].sep_type); }
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1598 "parse.y"
    { (yyval.sep_type) = 0; }
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1600 "parse.y"
    { (yyval.sep_type) = (yyvsp[(1) - (1)].sep_type); }
    break;



/* Line 1455 of yacc.c  */
#line 4538 "parse.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1603 "parse.y"


// Generic error messages.

static void
yyerror (const char *s)
{
  int err_col = current_input_column - 1;

  std::ostringstream output_buf;

  if (reading_fcn_file || reading_script_file || reading_classdef_file)
    output_buf << "parse error near line " << input_line_number
	       << " of file " << curr_fcn_file_full_name;
  else
    output_buf << "parse error:";

  if (s && strcmp (s, "parse error") != 0)
    output_buf << "\n\n  " << s;

  output_buf << "\n\n";

  if (! current_input_line.empty ())
    {
      size_t len = current_input_line.length ();

      if (current_input_line[len-1] == '\n')
        current_input_line.resize (len-1);

      // Print the line, maybe with a pointer near the error token.

      output_buf << ">>> " << current_input_line << "\n";

      if (err_col == 0)
	err_col = len;

      for (int i = 0; i < err_col + 3; i++)
	output_buf << " ";

      output_buf << "^";
    }

  output_buf << "\n";

  std::string msg = output_buf.str ();

  parse_error ("%s", msg.c_str ());
}

// Error mesages for mismatched end tokens.

static void
end_error (const char *type, token::end_tok_type ettype, int l, int c)
{
  static const char *fmt
    = "`%s' command matched by `%s' near line %d column %d";

  switch (ettype)
    {
    case token::simple_end:
      error (fmt, type, "end", l, c);
      break;

    case token::for_end:
      error (fmt, type, "endfor", l, c);
      break;

    case token::function_end:
      error (fmt, type, "endfunction", l, c);
      break;

    case token::classdef_end:
      error (fmt, type, "endclassdef", l, c);
      break;

    case token::if_end:
      error (fmt, type, "endif", l, c);
      break;

    case token::switch_end:
      error (fmt, type, "endswitch", l, c); 
      break;

    case token::while_end:
      error (fmt, type, "endwhile", l, c); 
      break;

    case token::try_catch_end:
      error (fmt, type, "end_try_catch", l, c); 
      break;

    case token::unwind_protect_end:
      error (fmt, type, "end_unwind_protect", l, c); 
      break;

    default:
      panic_impossible ();
      break;
    }
}

// Check to see that end tokens are properly matched.

static bool
end_token_ok (token *tok, token::end_tok_type expected)
{
  bool retval = true;

  token::end_tok_type ettype = tok->ettype ();

  if (ettype != expected && ettype != token::simple_end)
    {
      retval = false;

      yyerror ("parse error");

      int l = tok->line ();
      int c = tok->column ();

      switch (expected)
	{
	case token::classdef_end:
	  end_error ("classdef", ettype, l, c);
	  break;

	case token::for_end:
	  end_error ("for", ettype, l, c);
	  break;

	case token::function_end:
	  end_error ("function", ettype, l, c);
	  break;

	case token::if_end:
	  end_error ("if", ettype, l, c);
	  break;

	case token::try_catch_end:
	  end_error ("try", ettype, l, c);
	  break;

	case token::switch_end:
	  end_error ("switch", ettype, l, c);
	  break;

	case token::unwind_protect_end:
	  end_error ("unwind_protect", ettype, l, c);
	  break;

	case token::while_end:
	  end_error ("while", ettype, l, c);
	  break;

	default:
	  panic_impossible ();
	  break;
	}
    }

  return retval;
}

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.

static void
maybe_warn_assign_as_truth_value (tree_expression *expr)
{
  if (expr->is_assignment_expression ()
      && expr->paren_count () < 2)
    {
      if (curr_fcn_file_full_name.empty ())
	warning_with_id
	  ("Octave:assign-as-truth-value",
	   "suggest parenthesis around assignment used as truth value");
      else
	warning_with_id
	  ("Octave:assign-as-truth-value",
	   "suggest parenthesis around assignment used as truth value near line %d, column %d in file `%s'",
	   expr->line (), expr->column (), curr_fcn_file_full_name.c_str ());
    }
}

// Maybe print a warning about switch labels that aren't constants.

static void
maybe_warn_variable_switch_label (tree_expression *expr)
{
  if (! expr->is_constant ())
    {
      if (curr_fcn_file_full_name.empty ())
	warning_with_id ("Octave:variable-switch-label",
			 "variable switch label");
      else
	warning_with_id
	  ("Octave:variable-switch-label",
	   "variable switch label near line %d, column %d in file `%s'",
	   expr->line (), expr->column (), curr_fcn_file_full_name.c_str ());
    }
}

static tree_expression *
fold (tree_binary_expression *e)
{
  tree_expression *retval = e;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (error_state);
  unwind_protect::protect_var (warning_state);

  unwind_protect::protect_var (discard_error_messages);
  unwind_protect::protect_var (discard_warning_messages);

  discard_error_messages = true;
  discard_warning_messages = true;

  tree_expression *op1 = e->lhs ();
  tree_expression *op2 = e->rhs ();

  octave_value::binary_op op_type = e->op_type ();

  if (op1->is_constant () && op2->is_constant ()
      && (! ((warning_enabled ("Octave:associativity-change")
	      && (op_type == POW || op_type == EPOW))
	     || (warning_enabled ("Octave:precedence-change")
		 && (op_type == EXPR_OR || op_type == EXPR_OR_OR)))))
    {
      octave_value tmp = e->rvalue1 ();

      if (! (error_state || warning_state))
	{
	  tree_constant *tc_retval
	    = new tree_constant (tmp, op1->line (), op1->column ());

	  std::ostringstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  tc_retval->stash_original_text (buf.str ());

	  delete e;

	  retval = tc_retval;
	}
    }

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

static tree_expression *
fold (tree_unary_expression *e)
{
  tree_expression *retval = e;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (error_state);
  unwind_protect::protect_var (warning_state);

  unwind_protect::protect_var (discard_error_messages);
  unwind_protect::protect_var (discard_warning_messages);

  discard_error_messages = true;
  discard_warning_messages = true;

  tree_expression *op = e->operand ();

  if (op->is_constant ())
    {
      octave_value tmp = e->rvalue1 ();

      if (! (error_state || warning_state))
	{
	  tree_constant *tc_retval
	    = new tree_constant (tmp, op->line (), op->column ());

	  std::ostringstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  tc_retval->stash_original_text (buf.str ());

	  delete e;

	  retval = tc_retval;
	}
    }

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

// Finish building a range.

static tree_expression *
finish_colon_expression (tree_colon_expression *e)
{
  tree_expression *retval = e;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (error_state);
  unwind_protect::protect_var (warning_state);

  unwind_protect::protect_var (discard_error_messages);
  unwind_protect::protect_var (discard_warning_messages);

  discard_error_messages = true;
  discard_warning_messages = true;

  tree_expression *base = e->base ();
  tree_expression *limit = e->limit ();
  tree_expression *incr = e->increment ();

  if (base)
    {
      if (limit)
	{
	  if (base->is_constant () && limit->is_constant ()
	      && (! incr || (incr && incr->is_constant ())))
	    {
	      octave_value tmp = e->rvalue1 ();

	      if (! (error_state || warning_state))
		{
		  tree_constant *tc_retval
		    = new tree_constant (tmp, base->line (), base->column ());

		  std::ostringstream buf;

		  tree_print_code tpc (buf);

		  e->accept (tpc);

		  tc_retval->stash_original_text (buf.str ());

		  delete e;

		  retval = tc_retval;
		}
	    }
	}
      else
	{
	  e->preserve_base ();
	  delete e;

	  // FIXME -- need to attempt constant folding here
	  // too (we need a generic way to do that).
	  retval = base;
	}
    }

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

// Make a constant.

static tree_constant *
make_constant (int op, token *tok_val)
{
  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_constant *retval = 0;

  switch (op)
    {
    case NUM:
      {
	octave_value tmp (tok_val->number ());
	retval = new tree_constant (tmp, l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case IMAG_NUM:
      {
	octave_value tmp (Complex (0.0, tok_val->number ()));
	retval = new tree_constant (tmp, l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case DQ_STRING:
    case SQ_STRING:
      {
	std::string txt = tok_val->text ();

        char delim = op == DQ_STRING ? '"' : '\'';
        octave_value tmp (txt, delim);

        if (txt.empty ())
          {
            if (op == DQ_STRING)
              tmp = octave_null_str::instance;
            else
              tmp = octave_null_sq_str::instance;
          }

	retval = new tree_constant (tmp, l, c);

	if (op == DQ_STRING)
	  txt = undo_string_escapes (txt);

	// FIXME -- maybe this should also be handled by
	// tok_val->text_rep () for character strings?
	retval->stash_original_text (delim + txt + delim);
      }
      break;

    default:
      panic_impossible ();
      break;
    }

  return retval;
}

// Make a function handle.

static tree_fcn_handle *
make_fcn_handle (token *tok_val)
{
  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_fcn_handle *retval = new tree_fcn_handle (tok_val->text (), l, c);

  return retval;
}

// Make an anonymous function handle.

static tree_anon_fcn_handle *
make_anon_fcn_handle (tree_parameter_list *param_list, tree_statement *stmt)
{
  // FIXME -- need to get these from the location of the @ symbol.

  int l = -1;
  int c = -1;

  tree_parameter_list *ret_list = 0;

  symbol_table::scope_id fcn_scope = symbol_table::current_scope ();

  if (symtab_context.empty ())
    panic_impossible ();

  symbol_table::set_scope (symtab_context.top ());

  symtab_context.pop ();

  stmt->set_print_flag (false);

  tree_statement_list *body = new tree_statement_list (stmt);

  body->mark_as_anon_function_body ();

  tree_anon_fcn_handle *retval
    = new tree_anon_fcn_handle (param_list, ret_list, body, fcn_scope, l, c);

  return retval;
}

static void
maybe_warn_associativity_change (tree_expression *op)
{
  if (op->paren_count () == 0 && op->is_binary_expression ())
    {
      tree_binary_expression *e
	= dynamic_cast<tree_binary_expression *> (op);

      octave_value::binary_op op_type = e->op_type ();

      if (op_type == octave_value::op_pow
	  || op_type == octave_value::op_el_pow)
	{
	  std::string op_str = octave_value::binary_op_as_string (op_type);

	  if (curr_fcn_file_full_name.empty ())
	    warning_with_id
	      ("Octave:associativity-change",
	       "meaning may have changed due to change in associativity for %s operator",
	       op_str.c_str ());
	  else
	    warning_with_id
	      ("Octave:associativity-change",
	       "meaning may have changed due to change in associativity for %s operator near line %d, column %d in file `%s'",
	       op_str.c_str (), op->line (), op->column (),
	       curr_fcn_file_full_name.c_str ());
	}
    }
}

// Build a binary expression.

static tree_expression *
make_binary_op (int op, tree_expression *op1, token *tok_val,
		tree_expression *op2)
{
  octave_value::binary_op t = octave_value::unknown_binary_op;

  switch (op)
    {
    case POW:
      t = octave_value::op_pow;
      maybe_warn_associativity_change (op1);
      break;

    case EPOW:
      t = octave_value::op_el_pow;
      maybe_warn_associativity_change (op1);
      break;

    case '+':
      t = octave_value::op_add;
      break;

    case '-':
      t = octave_value::op_sub;
      break;

    case '*':
      t = octave_value::op_mul;
      break;

    case '/':
      t = octave_value::op_div;
      break;

    case EMUL:
      t = octave_value::op_el_mul;
      break;

    case EDIV:
      t = octave_value::op_el_div;
      break;

    case LEFTDIV:
      t = octave_value::op_ldiv;
      break;

    case ELEFTDIV:
      t = octave_value::op_el_ldiv;
      break;

    case LSHIFT:
      t = octave_value::op_lshift;
      break;

    case RSHIFT:
      t = octave_value::op_rshift;
      break;

    case EXPR_LT:
      t = octave_value::op_lt;
      break;

    case EXPR_LE:
      t = octave_value::op_le;
      break;

    case EXPR_EQ:
      t = octave_value::op_eq;
      break;

    case EXPR_GE:
      t = octave_value::op_ge;
      break;

    case EXPR_GT:
      t = octave_value::op_gt;
      break;

    case EXPR_NE:
      t = octave_value::op_ne;
      break;

    case EXPR_AND:
      t = octave_value::op_el_and;
      break;

    case EXPR_OR:
      t = octave_value::op_el_or;
      if (op2->paren_count () == 0 && op2->is_binary_expression ())
        {
	  tree_binary_expression *e
	    = dynamic_cast<tree_binary_expression *> (op2);

	  if (e->op_type () == octave_value::op_el_and)
	    {
	      if (curr_fcn_file_full_name.empty ())
		warning_with_id
		  ("Octave:precedence-change",
		   "meaning may have changed due to change in precedence for & and | operators");
	      else
		warning_with_id
		  ("Octave:precedence-change",
		   "meaning may have changed due to change in precedence for & and | operators near line %d, column %d in file `%s'",
		   op2->line (), op2->column (),
		   curr_fcn_file_full_name.c_str ());
	    }
        }
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_binary_expression *e
    = maybe_compound_binary_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a boolean expression.

static tree_expression *
make_boolean_op (int op, tree_expression *op1, token *tok_val,
		 tree_expression *op2)
{
  tree_boolean_expression::type t;

  switch (op)
    {
    case EXPR_AND_AND:
      t = tree_boolean_expression::bool_and;
      break;

    case EXPR_OR_OR:
      t = tree_boolean_expression::bool_or;
      if (op2->paren_count () == 0 && op2->is_boolean_expression ())
        {
	  tree_boolean_expression *e
	    = dynamic_cast<tree_boolean_expression *> (op2);

	  if (e->op_type () == tree_boolean_expression::bool_and)
	    warning_with_id
	      ("Octave:precedence-change",
	       "meaning may have changed due to change in precedence for && and || operators");
        }
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_boolean_expression *e
    = new tree_boolean_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a prefix expression.

static tree_expression *
make_prefix_op (int op, tree_expression *op1, token *tok_val)
{
  octave_value::unary_op t = octave_value::unknown_unary_op;

  switch (op)
    {
    case EXPR_NOT:
      t = octave_value::op_not;
      break;

    case '+':
      t = octave_value::op_uplus;
      break;

    case '-':
      t = octave_value::op_uminus;
      break;

    case PLUS_PLUS:
      t = octave_value::op_incr;
      break;

    case MINUS_MINUS:
      t = octave_value::op_decr;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_prefix_expression *e
    = new tree_prefix_expression (op1, l, c, t);

  return fold (e);
}

// Build a postfix expression.

static tree_expression *
make_postfix_op (int op, tree_expression *op1, token *tok_val)
{
  octave_value::unary_op t = octave_value::unknown_unary_op;

  switch (op)
    {
    case QUOTE:
      t = octave_value::op_hermitian;
      break;

    case TRANSPOSE:
      t = octave_value::op_transpose;
      break;

    case PLUS_PLUS:
      t = octave_value::op_incr;
      break;

    case MINUS_MINUS:
      t = octave_value::op_decr;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_postfix_expression *e
    = new tree_postfix_expression (op1, l, c, t);

  return fold (e);
}

// Build an unwind-protect command.

static tree_command *
make_unwind_command (token *unwind_tok, tree_statement_list *body,
		     tree_statement_list *cleanup, token *end_tok,
		     octave_comment_list *lc, octave_comment_list *mc)
{
  tree_command *retval = 0;

  if (end_token_ok (end_tok, token::unwind_protect_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      int l = unwind_tok->line ();
      int c = unwind_tok->column ();

      retval = new tree_unwind_protect_command (body, cleanup,
						lc, mc, tc, l, c);
    }

  return retval;
}

// Build a try-catch command.

static tree_command *
make_try_command (token *try_tok, tree_statement_list *body,
		  tree_statement_list *cleanup, token *end_tok,
		  octave_comment_list *lc, octave_comment_list *mc)
{
  tree_command *retval = 0;

  if (end_token_ok (end_tok, token::try_catch_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      int l = try_tok->line ();
      int c = try_tok->column ();

      retval = new tree_try_catch_command (body, cleanup,
					   lc, mc, tc, l, c);
    }

  return retval;
}

// Build a while command.

static tree_command *
make_while_command (token *while_tok, tree_expression *expr,
		    tree_statement_list *body, token *end_tok,
		    octave_comment_list *lc)
{
  tree_command *retval = 0;

  maybe_warn_assign_as_truth_value (expr);

  if (end_token_ok (end_tok, token::while_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      lexer_flags.looping--;

      int l = while_tok->line ();
      int c = while_tok->column ();

      retval = new tree_while_command (expr, body, lc, tc, l, c);
    }

  return retval;
}

// Build a do-until command.

static tree_command *
make_do_until_command (token *until_tok, tree_statement_list *body,
		       tree_expression *expr, octave_comment_list *lc)
{
  tree_command *retval = 0;

  maybe_warn_assign_as_truth_value (expr);

  octave_comment_list *tc = octave_comment_buffer::get_comment ();

  lexer_flags.looping--;

  int l = until_tok->line ();
  int c = until_tok->column ();

  retval = new tree_do_until_command (expr, body, lc, tc, l, c);

  return retval;
}

// Build a for command.

static tree_command *
make_for_command (token *for_tok, tree_argument_list *lhs,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok, octave_comment_list *lc)
{
  tree_command *retval = 0;

  if (end_token_ok (end_tok, token::for_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      lexer_flags.looping--;

      int l = for_tok->line ();
      int c = for_tok->column ();

      if (lhs->length () == 1)
	{
	  tree_expression *tmp = lhs->remove_front ();

	  retval = new tree_simple_for_command (tmp, expr, body,
						lc, tc, l, c);

	  delete lhs;
	}
      else
	retval = new tree_complex_for_command (lhs, expr, body,
					       lc, tc, l, c);
    }

  return retval;
}

// Build a break command.

static tree_command *
make_break_command (token *break_tok)
{
  tree_command *retval = 0;

  int l = break_tok->line ();
  int c = break_tok->column ();

  // We check to see if we are evaluating a function, script, or loop
  // so that we don't turn eval ("break;") inside a function, script,
  // or loop into a no-op command.

  if (lexer_flags.looping || current_function_depth > 0
      || reading_script_file || tree_evaluator::in_fcn_or_script_body
      || tree_evaluator::in_loop_command)
    retval = new tree_break_command (l, c);
  else
    retval = new tree_no_op_command ("break", l, c);

  return retval;
}

// Build a continue command.

static tree_command *
make_continue_command (token *continue_tok)
{
  tree_command *retval = 0;

  int l = continue_tok->line ();
  int c = continue_tok->column ();

  // We check to see if we are evaluating a loop so that we don't turn
  // eval ("continue;") into a no-op command inside a loop.

  if (lexer_flags.looping || tree_evaluator::in_loop_command)
    retval = new tree_continue_command (l, c);
  else
    retval = new tree_no_op_command ("continue", l, c);

  return retval;
}

// Build a return command.

static tree_command *
make_return_command (token *return_tok)
{
  tree_command *retval = 0;

  int l = return_tok->line ();
  int c = return_tok->column ();

  if (Vdebugging)
    {
      Vdebugging = false;

      retval = new tree_no_op_command ("return", l, c);
    }
  else
    {
      // We check to see if we are evaluating a function or script so
      // that we don't turn eval ("return;") inside a function, script,
      // or loop into a no-op command.

      if (current_function_depth > 0 || reading_script_file
          || tree_evaluator::in_fcn_or_script_body)
        retval = new tree_return_command (l, c);
      else
        retval = new tree_no_op_command ("return", l, c);
    }

  return retval;
}

// Start an if command.

static tree_if_command_list *
start_if_command (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_assign_as_truth_value (expr);

  tree_if_clause *t = new tree_if_clause (expr, list);

  return new tree_if_command_list (t);
}

// Finish an if command.

static tree_if_command *
finish_if_command (token *if_tok, tree_if_command_list *list,
		   token *end_tok, octave_comment_list *lc)
{
  tree_if_command *retval = 0;

  if (end_token_ok (end_tok, token::if_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      int l = if_tok->line ();
      int c = if_tok->column ();

      if (list && ! list->empty ())
	{
	  tree_if_clause *elt = list->front ();

	  if (elt)
	    {
	      elt->line (l);
	      elt->column (c);
	    }
	}

      retval = new tree_if_command (list, lc, tc, l, c);
    }

  return retval;
}

// Build an elseif clause.

static tree_if_clause *
make_elseif_clause (token *elseif_tok, tree_expression *expr,
		    tree_statement_list *list, octave_comment_list *lc)
{
  maybe_warn_assign_as_truth_value (expr);

  int l = elseif_tok->line ();
  int c = elseif_tok->column ();

  return new tree_if_clause (expr, list, lc, l, c);
}

// Finish a switch command.

static tree_switch_command *
finish_switch_command (token *switch_tok, tree_expression *expr,
		       tree_switch_case_list *list, token *end_tok,
		       octave_comment_list *lc)
{
  tree_switch_command *retval = 0;

  if (end_token_ok (end_tok, token::switch_end))
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      int l = switch_tok->line ();
      int c = switch_tok->column ();

      if (list && ! list->empty ())
	{
	  tree_switch_case *elt = list->front ();

	  if (elt)
	    {
	      elt->line (l);
	      elt->column (c);
	    }
	}

      retval = new tree_switch_command (expr, list, lc, tc, l, c);
    }

  return retval;
}

// Build a switch case.

static tree_switch_case *
make_switch_case (token *case_tok, tree_expression *expr,
		  tree_statement_list *list, octave_comment_list *lc)
{
  maybe_warn_variable_switch_label (expr);

  int l = case_tok->line ();
  int c = case_tok->column ();

  return new tree_switch_case (expr, list, lc, l, c);
}

// Build an assignment to a variable.

static tree_expression *
make_assign_op (int op, tree_argument_list *lhs, token *eq_tok,
		tree_expression *rhs)
{
  tree_expression *retval = 0;

  octave_value::assign_op t = octave_value::unknown_assign_op;

  switch (op)
    {
    case '=':
      t = octave_value::op_asn_eq;
      break;

    case ADD_EQ:
      t = octave_value::op_add_eq;
      break;

    case SUB_EQ:
      t = octave_value::op_sub_eq;
      break;

    case MUL_EQ:
      t = octave_value::op_mul_eq;
      break;

    case DIV_EQ:
      t = octave_value::op_div_eq;
      break;

    case LEFTDIV_EQ:
      t = octave_value::op_ldiv_eq;
      break;

    case POW_EQ:
      t = octave_value::op_pow_eq;
      break;

    case LSHIFT_EQ:
      t = octave_value::op_lshift_eq;
      break;

    case RSHIFT_EQ:
      t = octave_value::op_rshift_eq;
      break;

    case EMUL_EQ:
      t = octave_value::op_el_mul_eq;
      break;

    case EDIV_EQ:
      t = octave_value::op_el_div_eq;
      break;

    case ELEFTDIV_EQ:
      t = octave_value::op_el_ldiv_eq;
      break;

    case EPOW_EQ:
      t = octave_value::op_el_pow_eq;
      break;

    case AND_EQ:
      t = octave_value::op_el_and_eq;
      break;

    case OR_EQ:
      t = octave_value::op_el_or_eq;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = eq_tok->line ();
  int c = eq_tok->column ();

  if (lhs->is_simple_assign_lhs ())
    {
      tree_expression *tmp = lhs->remove_front ();

      retval = new tree_simple_assignment (tmp, rhs, false, l, c, t);

      delete lhs;
    }
  else
    return new tree_multi_assignment (lhs, rhs, false, l, c, t);

  return retval;
}

// Define a script.

static void
make_script (tree_statement_list *cmds, tree_statement *end_script)
{
  std::string doc_string;

  if (! help_buf.empty ())
    {
      doc_string = help_buf.top ();
      help_buf.pop ();
    }

  if (! cmds)
    cmds = new tree_statement_list ();

  cmds->append (end_script);

  octave_user_script *script
    = new octave_user_script (curr_fcn_file_full_name, curr_fcn_file_name,
			      cmds, doc_string);

  octave_time now;

  script->stash_fcn_file_time (now);

  primary_fcn_ptr = script;

  // Unmark any symbols that may have been tagged as local variables
  // while parsing (for example, by force_local_variable in lex.l).

  symbol_table::unmark_forced_variables ();
}

// Begin defining a function.

static octave_user_function *
start_function (tree_parameter_list *param_list, tree_statement_list *body,
		tree_statement *end_fcn_stmt)
{
  // We'll fill in the return list later.

  if (! body)
    body = new tree_statement_list ();

  body->append (end_fcn_stmt);

  octave_user_function *fcn
    = new octave_user_function (symbol_table::current_scope (),
				param_list, 0, body);

  if (fcn)
    {
      octave_comment_list *tc = octave_comment_buffer::get_comment ();

      fcn->stash_trailing_comment (tc);
    }

  return fcn;
}

static tree_statement *
make_end (const std::string& type, int l, int c)
{
  return make_statement (new tree_no_op_command (type, l, c));
}

// Do most of the work for defining a function.

static octave_user_function *
frob_function (const std::string& fname, octave_user_function *fcn)
{
  std::string id_name = fname;

  // If input is coming from a file, issue a warning if the name of
  // the file does not match the name of the function stated in the
  // file.  Matlab doesn't provide a diagnostic (it ignores the stated
  // name).
  if (! autoloading && reading_fcn_file
      && (current_function_depth == 1
	  && ! (parsing_subfunctions || lexer_flags.parsing_class_method)))
  {
    // FIXME -- should curr_fcn_file_name already be
    // preprocessed when we get here?  It seems to only be a
    // problem with relative file names.

    std::string nm = curr_fcn_file_name;

    size_t pos = nm.find_last_of (file_ops::dir_sep_chars ());

    if (pos != std::string::npos)
      nm = curr_fcn_file_name.substr (pos+1);

    if (nm != id_name)
      {
	warning_with_id
	  ("Octave:function-name-clash",
	   "function name `%s' does not agree with function file name `%s'",
	   id_name.c_str (), curr_fcn_file_full_name.c_str ());

	id_name = nm;
      }
  }

  if (reading_fcn_file || reading_classdef_file || autoloading)
    {
      octave_time now;

      fcn->stash_fcn_file_name (curr_fcn_file_full_name);
      fcn->stash_fcn_file_time (now);
      fcn->mark_as_system_fcn_file ();

      if (fcn_file_from_relative_lookup)
	fcn->mark_relative ();

      if (current_function_depth > 1 || parsing_subfunctions)
        {
	  fcn->stash_parent_fcn_name (curr_fcn_file_name);
	  fcn->stash_parent_fcn_scope (primary_fcn_scope);
        }

      if (lexer_flags.parsing_class_method)
	{
	  if (current_class_name == id_name)
	    fcn->mark_as_class_constructor ();
	  else
	    fcn->mark_as_class_method ();

	  fcn->stash_dispatch_class (current_class_name);
	}

      std::string nm = fcn->fcn_file_name ();

      file_stat fs (nm);

      if (fs && fs.is_newer (now))
        warning_with_id ("Octave:future-time-stamp",
			 "time stamp for `%s' is in the future", nm.c_str ());
    }
  else if (! (input_from_tmp_history_file || input_from_startup_file)
	   && reading_script_file
	   && curr_fcn_file_name == id_name)
    {
      warning ("function `%s' defined within script file `%s'",
	       id_name.c_str (), curr_fcn_file_full_name.c_str ());
    }

  fcn->stash_function_name (id_name);

  if (! help_buf.empty () && current_function_depth == 1
      && ! parsing_subfunctions)
    {
      fcn->document (help_buf.top ());

      help_buf.pop ();
    }

  if (reading_fcn_file && current_function_depth == 1
      && ! parsing_subfunctions)
    primary_fcn_ptr = fcn;
  
  return fcn;
}

static tree_function_def *
finish_function (tree_parameter_list *ret_list,
		 octave_user_function *fcn, octave_comment_list *lc)
{
  tree_function_def *retval = 0;

  if (ret_list)
    ret_list->mark_as_formal_parameters ();

  if (fcn)
    {
      std::string nm = fcn->name ();
      std::string file = fcn->fcn_file_name ();

      std::string tmp = nm;
      if (! file.empty ())
	tmp += ": " + file;

      symbol_table::cache_name (fcn->scope (), tmp);

      if (lc)
	fcn->stash_leading_comment (lc);

      fcn->define_ret_list (ret_list);

      if (current_function_depth > 1 || parsing_subfunctions)
        {
          // FIXME -- is this flag used to determine if the function is a
          // _subfunction_ somewhere?
	  fcn->mark_as_nested_function ();

	  symbol_table::install_subfunction (nm, octave_value (fcn),
					     primary_fcn_scope);
	}

      if (! primary_fcn_ptr)
	{
	  // FIXME -- there should be a better way to indicate that we
	  // should create a tree_function_def object other than
	  // looking at primary_fcn_ptr...

	  retval = new tree_function_def (fcn);
	}

      // Unmark any symbols that may have been tagged as local
      // variables while parsing (for example, by force_local_variable
      // in lex.l).

      symbol_table::unmark_forced_variables (fcn->scope ());
    }

  return retval;
}

static void
recover_from_parsing_function (void)
{
  if (symtab_context.empty ())
    panic_impossible ();

  symbol_table::set_scope (symtab_context.top ());
  symtab_context.pop ();

  if (reading_fcn_file && current_function_depth == 1
      && ! parsing_subfunctions)
    parsing_subfunctions = true;

  current_function_depth--;

  lexer_flags.parsed_function_name = false;
  lexer_flags.looking_at_return_list = false;
  lexer_flags.looking_at_parameter_list = false;
}

// Make an index expression.

static tree_index_expression *
make_index_expression (tree_expression *expr, tree_argument_list *args,
		       char type)
{
  tree_index_expression *retval = 0;

  int l = expr->line ();
  int c = expr->column ();

  expr->mark_postfix_indexed ();

  if (expr->is_index_expression ())
    {
      tree_index_expression *tmp = static_cast<tree_index_expression *> (expr);

      tmp->append (args, type);

      retval = tmp;
    }
  else
    retval = new tree_index_expression (expr, args, l, c, type);

  return retval;
}

// Make an indirect reference expression.

static tree_index_expression *
make_indirect_ref (tree_expression *expr, const std::string& elt)
{
  tree_index_expression *retval = 0;

  int l = expr->line ();
  int c = expr->column ();

  if (expr->is_index_expression ())
    {
      tree_index_expression *tmp = static_cast<tree_index_expression *> (expr);

      tmp->append (elt);

      retval = tmp;
    }
  else
    retval = new tree_index_expression (expr, elt, l, c);

  lexer_flags.looking_at_indirect_ref = false;

  return retval;
}

// Make an indirect reference expression with dynamic field name.

static tree_index_expression *
make_indirect_ref (tree_expression *expr, tree_expression *elt)
{
  tree_index_expression *retval = 0;

  int l = expr->line ();
  int c = expr->column ();

  if (expr->is_index_expression ())
    {
      tree_index_expression *tmp = static_cast<tree_index_expression *> (expr);

      tmp->append (elt);

      retval = tmp;
    }
  else
    retval = new tree_index_expression (expr, elt, l, c);

  lexer_flags.looking_at_indirect_ref = false;

  return retval;
}

// Make a declaration command.

static tree_decl_command *
make_decl_command (int tok, token *tok_val, tree_decl_init_list *lst)
{
  tree_decl_command *retval = 0;

  int l = tok_val->line ();
  int c = tok_val->column ();

  switch (tok)
    {
    case GLOBAL:
      retval = new tree_global_command (lst, l, c);
      break;

    case STATIC:
      if (current_function_depth > 0)
	retval = new tree_static_command (lst, l, c);
      else
	{
	  if (reading_script_file)
	    warning ("ignoring persistent declaration near line %d of file `%s'",
		     l, curr_fcn_file_full_name.c_str ());
	  else
	    warning ("ignoring persistent declaration near line %d", l);
	}
      break;

    default:
      panic_impossible ();
      break;
    }

  return retval;
}

// Finish building a matrix list.

static tree_expression *
finish_matrix (tree_matrix *m)
{
  tree_expression *retval = m;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (error_state);
  unwind_protect::protect_var (warning_state);

  unwind_protect::protect_var (discard_error_messages);
  unwind_protect::protect_var (discard_warning_messages);

  discard_error_messages = true;
  discard_warning_messages = true;

  if (m->all_elements_are_constant ())
    {
      octave_value tmp = m->rvalue1 ();

      if (! (error_state || warning_state))
	{
	  tree_constant *tc_retval
	    = new tree_constant (tmp, m->line (), m->column ());

	  std::ostringstream buf;

	  tree_print_code tpc (buf);

	  m->accept (tpc);

	  tc_retval->stash_original_text (buf.str ());

	  delete m;

	  retval = tc_retval;
	}
    }

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

// Finish building a cell list.

static tree_expression *
finish_cell (tree_cell *c)
{
  return finish_matrix (c);
}

static void
maybe_warn_missing_semi (tree_statement_list *t)
{
  if (current_function_depth > 0)
    {
      tree_statement *tmp = t->back();

      if (tmp->is_expression ())
	warning_with_id
	  ("Octave:missing-semicolon",
	   "missing semicolon near line %d, column %d in file `%s'",
	    tmp->line (), tmp->column (), curr_fcn_file_full_name.c_str ());
    }
}

static tree_statement_list *
set_stmt_print_flag (tree_statement_list *list, char sep,
		     bool warn_missing_semi)
{
  tree_statement *tmp = list->back ();

  switch (sep)
    {
    case ';':
      tmp->set_print_flag (false);
      break;

    case 0:
    case ',':
    case '\n':
      tmp->set_print_flag (true);
      if (warn_missing_semi)
	maybe_warn_missing_semi (list);
      break;

    default:
      warning ("unrecognized separator type!");
      break;
    }

  // Even if a statement is null, we add it to the list then remove it
  // here so that the print flag is applied to the correct statement.

  if (tmp->is_null_statement ())
    {
      list->pop_back ();
      delete tmp;
    }

  return list;
}

static tree_statement_list *
make_statement_list (tree_statement *stmt)
{
  return new tree_statement_list (stmt);
}

static tree_statement_list *
append_statement_list (tree_statement_list *list, char sep,
		       tree_statement *stmt, bool warn_missing_semi)
{
  set_stmt_print_flag (list, sep, warn_missing_semi);

  list->append (stmt);

  return list;
}

static void
safe_fclose (void *f)
{
  // FIXME -- comments at the end of an input file are
  // discarded (otherwise, they would be appended to the next
  // statement, possibly from the command line or another file, which
  // can be quite confusing).

  octave_comment_list *tc = octave_comment_buffer::get_comment ();

  delete tc;

  if (f)
    fclose (static_cast<FILE *> (f));
}

static bool
looks_like_copyright (const std::string& s)
{
  bool retval = false;

  if (! s.empty ())
    {
      size_t offset = s.find_first_not_of (" \t");
  
      retval = (s.substr (offset, 9) == "Copyright");
    }

  return retval;
}

static int
text_getc (FILE *f)
{
  int c = getc (f);

  // Convert CRLF into just LF and single CR into LF.

  if (c == '\r')
    {
      c = getc (f);

      if (c != '\n')
	{
	  ungetc (c, f);
	  c = '\n';
	}
    }

  if (c == '\n')
    input_line_number++;

  return c;
}

class
stdio_stream_reader : public stream_reader
{
public:
  stdio_stream_reader (FILE *f_arg) : stream_reader (), f (f_arg) { }

  int getc (void) { return ::text_getc (f); }
  int ungetc (int c)
  {
    if (c == '\n')
      input_line_number--;

    return ::ungetc (c, f);
  }
  
private:
  FILE *f;
};

static bool
skip_white_space (stream_reader& reader)
{
  int c = 0;

  while ((c = reader.getc ()) != EOF)
    {
      switch (c)
	{
	case ' ':
	case '\t':
	  current_input_column++;
	  break;

	case '\n':
	  current_input_column = 0;
	  break;

	default:
	  current_input_column--;
	  reader.ungetc (c);
	  goto done;
	}
    }

 done:

  return (c == EOF);
}

static bool
looking_at_classdef_keyword (FILE *ffile)
{
  bool status = false;

  long pos = ftell (ffile);

  char buf [10];
  fgets (buf, 10, ffile);
  size_t len = strlen (buf);
  if (len > 8 && strncmp (buf, "classdef", 8) == 0
      && ! (isalnum (buf[8]) || buf[8] == '_'))
    status = true;

  fseek (ffile, pos, SEEK_SET);

  return status;
 }

static std::string
gobble_leading_white_space (FILE *ffile, bool& eof)
{
  std::string help_txt;

  eof = false;

  // TRUE means we have already cached the help text.
  bool have_help_text = false;

  std::string txt;

  stdio_stream_reader stdio_reader (ffile);

  while (true)
    {
      eof = skip_white_space (stdio_reader);

      if (eof)
	break;

      txt = grab_comment_block (stdio_reader, true, eof);

      if (txt.empty ())
	break;

      if (! (have_help_text || looks_like_copyright (txt)))
	{
	  help_txt = txt;
	  have_help_text = true;
	}

      octave_comment_buffer::append (txt);

      if (eof)
	break;
    }

  return help_txt;
}

static bool
looking_at_function_keyword (FILE *ffile)
{
  bool status = false;

  long pos = ftell (ffile);

  char buf [10];
  fgets (buf, 10, ffile);
  size_t len = strlen (buf);
  if (len > 8 && strncmp (buf, "function", 8) == 0
      && ! (isalnum (buf[8]) || buf[8] == '_'))
    status = true;

  fseek (ffile, pos, SEEK_SET);

  return status;
}

static octave_function *
parse_fcn_file (const std::string& ff, const std::string& dispatch_type,
		bool force_script = false, bool require_file = true,
		const std::string& warn_for = std::string ())
{
  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  octave_function *fcn_ptr = 0;

  // Open function file and parse.

  FILE *in_stream = command_editor::get_input_stream ();

  unwind_protect::add_fcn (command_editor::set_input_stream,
                           in_stream);

  unwind_protect::protect_var (ff_instream);

  unwind_protect::protect_var (input_line_number);
  unwind_protect::protect_var (current_input_column);
  unwind_protect::protect_var (reading_fcn_file);
  unwind_protect::protect_var (line_editing);
  unwind_protect::protect_var (current_class_name);
  unwind_protect::protect_var (current_function_depth);
  unwind_protect::protect_var (max_function_depth);
  unwind_protect::protect_var (parsing_subfunctions);
  unwind_protect::protect_var (endfunction_found);

  input_line_number = 1;
  current_input_column = 1;
  reading_fcn_file = true;
  line_editing = false;
  current_class_name = dispatch_type;
  current_function_depth = 0;
  max_function_depth = 0;
  parsing_subfunctions = false;
  endfunction_found = false;

  // The next four lines must be in this order.
  unwind_protect::add_fcn (command_history::ignore_entries, ! Vsaving_history);

  // FIXME -- we shouldn't need both the
  // command_history object and the
  // Vsaving_history variable...
  command_history::ignore_entries ();

  unwind_protect::protect_var (Vsaving_history);

  Vsaving_history = false;

  FILE *ffile = get_input_from_file (ff, 0);

  unwind_protect::add (safe_fclose, ffile);

  if (ffile)
    {
      bool eof;

      std::string help_txt = gobble_leading_white_space (ffile, eof);

      if (! eof)
	{
	  std::string file_type;

	  unwind_protect::protect_var (get_input_from_eval_string);
	  unwind_protect::protect_var (parser_end_of_input);
	  unwind_protect::protect_var (reading_fcn_file);
	  unwind_protect::protect_var (reading_script_file);
	  unwind_protect::protect_var (reading_classdef_file);
	  unwind_protect::protect_var (Vecho_executing_commands);


	  get_input_from_eval_string = false;
	  parser_end_of_input = false;

	  if (! force_script && looking_at_function_keyword (ffile))
	    {
	      file_type = "function";

	      Vecho_executing_commands = ECHO_OFF;

	      reading_classdef_file = false;
	      reading_fcn_file = true;
	      reading_script_file = false;
	    }
	  else if (! force_script && looking_at_classdef_keyword (ffile))
	    {
	      file_type = "classdef";

	      Vecho_executing_commands = ECHO_OFF;

	      reading_classdef_file = true;
	      reading_fcn_file = false;
	      reading_script_file = false;
	    }
	  else
	    {
	      file_type = "script";

	      Vecho_executing_commands = ECHO_OFF;

	      reading_classdef_file = false;
	      reading_fcn_file = false;
	      reading_script_file = true;
	    }

	  YY_BUFFER_STATE old_buf = current_buffer ();
	  YY_BUFFER_STATE new_buf = create_buffer (ffile);

	  unwind_protect::add_fcn (switch_to_buffer, old_buf);
	  unwind_protect::add_fcn (delete_buffer, new_buf);

	  switch_to_buffer (new_buf);

	  unwind_protect::protect_var (primary_fcn_ptr);
	  primary_fcn_ptr = 0;

	  reset_parser ();

	  // Do this with an unwind-protect cleanup function so that
	  // the forced variables will be unmarked in the event of an
	  // interrupt. 
	  symbol_table::scope_id scope = symbol_table::top_scope ();
	  unwind_protect::add_fcn (symbol_table::unmark_forced_variables, scope);

	  if (! help_txt.empty ())
	    help_buf.push (help_txt);

	  if (reading_script_file)
	    prep_lexer_for_script_file ();
	  else
	    prep_lexer_for_function_file ();

	  lexer_flags.parsing_class_method = ! dispatch_type.empty ();

	  int status = yyparse ();

	  fcn_ptr = primary_fcn_ptr;

	  if (reading_fcn_file && endfunction_found && max_function_depth > 1)
	    warning_with_id ("Octave:nested-functions-coerced",
			     "nested functions are coerced into subfunctions "
			     "in file %s", ff.c_str ());

	  if (status != 0)
	    error ("parse error while reading %s file %s",
		   file_type.c_str(), ff.c_str ());
	}
    }
  else if (require_file)
    error ("no such file, `%s'", ff.c_str ());
  else if (! warn_for.empty ())
    error ("%s: unable to open file `%s'", warn_for.c_str (), ff.c_str ());    

  unwind_protect::run_frame (uwp_frame);

  return fcn_ptr;
}

std::string
get_help_from_file (const std::string& nm, bool& symbol_found,
		    std::string& file)
{
  std::string retval;

  file = fcn_file_in_path (nm);

  if (! file.empty ())
    {
      symbol_found = true;

      FILE *fptr = fopen (file.c_str (), "r");

      if (fptr)
	{
	  unwind_protect::add (safe_fclose, fptr);

	  bool eof;
	  retval = gobble_leading_white_space (fptr, eof);

	  if (retval.empty ())
	    {
	      octave_function *fcn = parse_fcn_file (file, "");

	      if (fcn)
		{
		  retval = fcn->doc_string ();

		  delete fcn;
		}
	    }

	  unwind_protect::run ();
	}
    }

  return retval;
}

std::string
get_help_from_file (const std::string& nm, bool& symbol_found)
{
  std::string file;
  return get_help_from_file (nm, symbol_found, file);
}

std::string
lookup_autoload (const std::string& nm)
{
  std::string retval;

  typedef std::map<std::string, std::string>::const_iterator am_iter;

  am_iter p = autoload_map.find (nm);

  if (p != autoload_map.end ())
    retval = load_path::find_file (p->second);

  return retval;
}

string_vector 
autoloaded_functions (void)
{
  string_vector names (autoload_map.size());

  octave_idx_type i = 0;
  typedef std::map<std::string, std::string>::const_iterator am_iter;
  for (am_iter p = autoload_map.begin (); p != autoload_map.end (); p++)
    names[i++] = p->first;

  return names;
}

string_vector
reverse_lookup_autoload (const std::string& nm)
{
  string_vector names;

  typedef std::map<std::string, std::string>::const_iterator am_iter;
  for (am_iter p = autoload_map.begin (); p != autoload_map.end (); p++)
    if (nm == p->second)
      names.append (p->first);

  return names;
}

octave_function *
load_fcn_from_file (const std::string& file_name, const std::string& dir_name,
		    const std::string& dispatch_type,
		    const std::string& fcn_name, bool autoload)
{
  octave_function *retval = 0;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  std::string nm = file_name;

  size_t nm_len = nm.length ();

  std::string file;

  unwind_protect::protect_var (fcn_file_from_relative_lookup);

  fcn_file_from_relative_lookup = false;

  file = nm;

  if ((nm_len > 4 && nm.substr (nm_len-4) == ".oct")
      || (nm_len > 4 && nm.substr (nm_len-4) == ".mex")
      || (nm_len > 2 && nm.substr (nm_len-2) == ".m"))
    {
      nm = octave_env::base_pathname (file);
      nm = nm.substr (0, nm.find_last_of ('.'));
    }

  if (autoload)
    {
      unwind_protect::protect_var (autoloading);
      autoloading = true;
    }

  fcn_file_from_relative_lookup = ! octave_env::absolute_pathname (file);

  file = octave_env::make_absolute (file, octave_env::getcwd ());

  int len = file.length ();

  if (len > 4 && file.substr (len-4, len-1) == ".oct")
    {
      if (autoload && ! fcn_name.empty ())
	nm = fcn_name;

      retval = octave_dynamic_loader::load_oct (nm, file, fcn_file_from_relative_lookup);
    }
  else if (len > 4 && file.substr (len-4, len-1) == ".mex")
    retval = octave_dynamic_loader::load_mex (nm, file, fcn_file_from_relative_lookup);
  else if (len > 2)
    {
      // These are needed by yyparse.

      unwind_protect::protect_var (curr_fcn_file_name);
      unwind_protect::protect_var (curr_fcn_file_full_name);

      curr_fcn_file_name = nm;
      curr_fcn_file_full_name = file;

      retval = parse_fcn_file (file, dispatch_type, autoloading);
    }

  if (retval)
    {
      retval->stash_dir_name (dir_name);

      if (retval->is_user_function ())
	{
	  symbol_table::scope_id id = retval->scope ();

	  symbol_table::stash_dir_name_for_subfunctions (id, dir_name);
	}
    }

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

DEFUN (autoload, args, ,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} autoload (@var{function}, @var{file})\n\
Define @var{function} to autoload from @var{file}.\n\
\n\
The second argument, @var{file}, should be an absolute file name or\n\
a file name in the same directory as the function or script from which\n\
the autoload command was run.  @var{file} should not depend on the\n\
Octave load path.\n\
\n\
Normally, calls to @code{autoload} appear in PKG_ADD script files that\n\
are evaluated when a directory is added to the Octave's load path.  To\n\
avoid having to hardcode directory names in @var{file}, if @var{file}\n\
is in the same directory as the PKG_ADD script then\n\
\n\
@example\n\
autoload (\"foo\", \"bar.oct\");\n\
@end example\n\
\n\
will load the function @code{foo} from the file @code{bar.oct}.  The above\n\
when @code{bar.oct} is not in the same directory or uses like\n\
\n\
@example\n\
autoload (\"foo\", file_in_loadpath (\"bar.oct\"))\n\
@end example\n\
\n\
@noindent\n\
are strongly discouraged, as their behavior might be unpredictable.\n\
\n\
With no arguments, return a structure containing the current autoload map.\n\
@seealso{PKG_ADD}\n\
@end deftypefn")
{
  octave_value retval;

  int nargin = args.length ();

  if (nargin == 0)
    {
      Cell func_names (dim_vector (autoload_map.size ()), 1);
      Cell file_names (dim_vector (autoload_map.size ()), 1);

      octave_idx_type i = 0;
      typedef std::map<std::string, std::string>::const_iterator am_iter;
      for (am_iter p = autoload_map.begin (); p != autoload_map.end (); p++)
	{
	  func_names(i) = p->first;
	  file_names(i) = p->second;

	  i++;
	}

      Octave_map m;

      m.assign ("function", func_names);
      m.assign ("file", file_names);

      retval = m;
    }
  else if (nargin == 2)
    {
      string_vector argv = args.make_argv ("autoload");

      if (! error_state)
        {
	  std::string nm = argv[2];

	  if (! octave_env::absolute_pathname (nm))
	    {
	      octave_user_code *fcn = octave_call_stack::caller_user_code ();

	      bool found = false;

	      if (fcn)
		{
		  std::string fname = fcn->fcn_file_name ();

		  if (! fname.empty ())
		    {
		      fname = octave_env::make_absolute (fname, octave_env::getcwd ());
		      fname = fname.substr (0, fname.find_last_of (file_ops::dir_sep_str ()) + 1);

		      file_stat fs (fname + nm);

		      if (fs.exists ())
			{
			  nm = fname + nm;
			  found = true;
			}
		    }
		}
	      if (! found)
		warning_with_id ("Octave:autoload-relative-file-name",
				 "autoload: `%s' is not an absolute file name",
				 nm.c_str ());
	    }
	  autoload_map[argv[1]] = nm;
	}
    }
  else
    print_usage ();

  return retval;
}

void
source_file (const std::string& file_name, const std::string& context,
	     bool verbose, bool require_file, const std::string& warn_for)
{
  std::string file_full_name = file_ops::tilde_expand (file_name);

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (curr_fcn_file_name);
  unwind_protect::protect_var (curr_fcn_file_full_name);

  curr_fcn_file_name = file_name;
  curr_fcn_file_full_name = file_full_name;

  if (! context.empty ())
    {
      if (context == "caller")
	octave_call_stack::goto_caller_frame ();
      else if (context == "base")
	octave_call_stack::goto_base_frame ();
      else
	error ("source: context must be \"caller\" or \"base\"");

      if (! error_state)
	unwind_protect::add_fcn (octave_call_stack::pop);
    }      

  if (! error_state)
    {
      octave_function *fcn = parse_fcn_file (file_full_name, "", true,
					     require_file, warn_for);

      if (! error_state)
	{
	  if (fcn && fcn->is_user_script ())
	    {
	      octave_value_list args;

	      if (verbose)
		{
		  std::cout << "executing commands from " << file_full_name << " ... ";
		  reading_startup_message_printed = true;
		  std::cout.flush ();
		}

	      fcn->do_multi_index_op (0, args);

	      if (verbose)
		std::cout << "done." << std::endl;

	      delete fcn;
	    }
	}
      else
	error ("source: error sourcing file `%s'",
	       file_full_name.c_str ());
    }

  unwind_protect::run_frame (uwp_frame);
}

DEFUN (mfilename, args, ,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} mfilename ()\n\
@deftypefnx {Built-in Function} {} mfilename (@code{\"fullpath\"})\n\
@deftypefnx {Built-in Function} {} mfilename (@code{\"fullpathext\"})\n\
Return the name of the currently executing file.  At the top-level,\n\
return the empty string.  Given the argument @code{\"fullpath\"},\n\
include the directory part of the file name, but not the extension.\n\
Given the argument @code{\"fullpathext\"}, include the directory part\n\
of the file name and the extension.\n\
@end deftypefn")
{
  octave_value retval;

  int nargin = args.length ();

  if (nargin > 1)
    {
      print_usage ();
      return retval;
    }

  std::string arg;

  if (nargin == 1)
    {
      arg = args(0).string_value ();

      if (error_state)
	{
	  error ("mfilename: expecting argument to be a character string");
	  return retval;
	}
    }

  std::string fname;

  octave_user_code *fcn = octave_call_stack::caller_user_code ();

  if (fcn)
    {
      fname = fcn->fcn_file_name ();

      if (fname.empty ())
        fname = fcn->name ();
    }

  if (arg == "fullpathext")
    retval = fname;
  else
    {
      size_t dpos = fname.rfind (file_ops::dir_sep_char ());
      size_t epos = fname.rfind ('.');

      if (epos <= dpos)
        epos = std::string::npos;

      fname = (epos != std::string::npos) ? fname.substr (0, epos) : fname;

      if (arg == "fullpath")
	retval = fname;
      else
        retval = (dpos != std::string::npos) ? fname.substr (dpos+1) : fname;
    }

  return retval;
}


DEFUN (source, args, ,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} source (@var{file})\n\
Parse and execute the contents of @var{file}.  This is equivalent to\n\
executing commands from a script file, but without requiring the file to\n\
be named @file{@var{file}.m}.\n\
@end deftypefn")
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin == 1 || nargin == 2)
    {
      std::string file_name = args(0).string_value ();

      if (! error_state)
	{
	  std::string context;

	  if (nargin == 2)
	    context = args(1).string_value ();

	  if (! error_state)
	    source_file (file_name, context);
	  else
	    error ("source: expecting context to be character string");
	}
      else
	error ("source: expecting file name as argument");
    }
  else
    print_usage ();

  return retval;
}

// Evaluate an Octave function (built-in or interpreted) and return
// the list of result values.  NAME is the name of the function to
// call.  ARGS are the arguments to the function.  NARGOUT is the
// number of output arguments expected. 

octave_value_list
feval (const std::string& name, const octave_value_list& args, int nargout)
{
  octave_value_list retval;

  octave_value fcn = symbol_table::find_function (name, args);

  if (fcn.is_defined ())
    retval = fcn.do_multi_index_op (nargout, args);
  else
    error ("feval: function `%s' not found", name.c_str ());

  return retval;
}

octave_value_list
feval (octave_function *fcn, const octave_value_list& args, int nargout)
{
  octave_value_list retval;

  if (fcn)
    retval = fcn->do_multi_index_op (nargout, args);

  return retval;
}

static octave_value_list
get_feval_args (const octave_value_list& args)
{
  int tmp_nargin = args.length () - 1;

  octave_value_list retval (tmp_nargin, octave_value ());

  for (int i = 0; i < tmp_nargin; i++)
    retval(i) = args(i+1);

  string_vector arg_names = args.name_tags ();

  if (! arg_names.empty ())
    {
      // tmp_nargin and arg_names.length () - 1 may differ if
      // we are passed all_va_args.

      int n = arg_names.length () - 1;

      int len = n > tmp_nargin ? tmp_nargin : n;

      string_vector tmp_arg_names (len);

      for (int i = 0; i < len; i++)
	tmp_arg_names(i) = arg_names(i+1);

      retval.stash_name_tags (tmp_arg_names);
    }

  return retval;
}


// Evaluate an Octave function (built-in or interpreted) and return
// the list of result values.  The first element of ARGS should be a
// string containing the name of the function to call, then the rest
// are the actual arguments to the function.  NARGOUT is the number of
// output arguments expected.

octave_value_list
feval (const octave_value_list& args, int nargout)
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin > 0)
    {
      octave_value f_arg = args(0);

      if (f_arg.is_string ())
        {
	  std::string name = f_arg.string_value ();

	  if (! error_state)
	    {
	      octave_value_list tmp_args = get_feval_args (args);

	      retval = feval (name, tmp_args, nargout);
	    }
	}
      else
	{
	  octave_function *fcn = f_arg.function_value ();

	  if (fcn)
	    {
	      octave_value_list tmp_args = get_feval_args (args);

	      retval = feval (fcn, tmp_args, nargout);
	    }
	}
    }

  return retval;
}

DEFUN (feval, args, nargout,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} feval (@var{name}, @dots{})\n\
Evaluate the function named @var{name}.  Any arguments after the first\n\
are passed on to the named function.  For example,\n\
\n\
@example\n\
feval (\"acos\", -1)\n\
     @result{} 3.1416\n\
@end example\n\
\n\
@noindent\n\
calls the function @code{acos} with the argument @samp{-1}.\n\
\n\
The function @code{feval} is necessary in order to be able to write\n\
functions that call user-supplied functions, because Octave does not\n\
have a way to declare a pointer to a function (like C) or to declare a\n\
special kind of variable that can be used to hold the name of a function\n\
(like @code{EXTERNAL} in Fortran).  Instead, you must refer to functions\n\
by name, and use @code{feval} to call them.\n\
@end deftypefn")
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin > 0)
    retval = feval (args, nargout);
  else
    print_usage ();

  return retval;
}

octave_value_list
eval_string (const std::string& s, bool silent, int& parse_status, int nargout)
{
  octave_value_list retval;

  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

  unwind_protect::protect_var (input_line_number);
  unwind_protect::protect_var (current_input_column);
  unwind_protect::protect_var (get_input_from_eval_string);
  unwind_protect::protect_var (input_from_eval_string_pending);
  unwind_protect::protect_var (parser_end_of_input);
  unwind_protect::protect_var (line_editing);
  unwind_protect::protect_var (current_eval_string);
  unwind_protect::protect_var (current_function_depth);
  unwind_protect::protect_var (max_function_depth);
  unwind_protect::protect_var (parsing_subfunctions);
  unwind_protect::protect_var (endfunction_found);

  input_line_number = 1;
  current_input_column = 1;
  get_input_from_eval_string = true;
  input_from_eval_string_pending = true;
  parser_end_of_input = false;
  line_editing = false;
  current_function_depth = 0;
  max_function_depth = 0;
  parsing_subfunctions = false;
  endfunction_found = false;

  current_eval_string = s;

  YY_BUFFER_STATE old_buf = current_buffer ();
  YY_BUFFER_STATE new_buf = create_buffer (0);

  unwind_protect::add_fcn (switch_to_buffer, old_buf);
  unwind_protect::add_fcn (delete_buffer, new_buf);

  switch_to_buffer (new_buf);

  do
    {
      reset_parser ();

      unwind_protect::protect_var (global_command);

      // Do this with an unwind-protect cleanup function so that the
      // forced variables will be unmarked in the event of an
      // interrupt.
      symbol_table::scope_id scope = symbol_table::top_scope ();
      unwind_protect::add_fcn (symbol_table::unmark_forced_variables, scope);

      parse_status = yyparse ();

      tree_statement_list *command_list = global_command;

      // Unmark forced variables.
      unwind_protect::run ();

      // Restore previous value of global_command.
      unwind_protect::run ();

      if (parse_status == 0)
        {
	  if (command_list)
	    {
	      tree_statement *stmt = 0;

	      if (command_list->length () == 1
		  && (stmt = command_list->front ())
		  && stmt->is_expression ())
		{
		  tree_expression *expr = stmt->expression ();

		  if (silent)
		    expr->set_print_flag (false);

		  bool do_bind_ans = false;

		  if (expr->is_identifier ())
		    {
		      tree_identifier *id
			= dynamic_cast<tree_identifier *> (expr);

		      do_bind_ans = (! id->is_variable ());
		    }
		  else
		    do_bind_ans = (! expr->is_assignment_expression ());

		  retval = expr->rvalue (nargout);

		  if (do_bind_ans && ! (error_state || retval.empty ()))
		    bind_ans (retval(0), expr->print_result ());

		  if (nargout == 0)
		    retval = octave_value_list ();
		}
	      else if (nargout == 0)
		command_list->accept (*current_evaluator);
	      else
		error ("eval: invalid use of statement list");

	      delete command_list;

	      command_list = 0;

	      if (error_state
		  || tree_return_command::returning
		  || tree_break_command::breaking
		  || tree_continue_command::continuing)
		break;
	    }
	  else if (parser_end_of_input)
	    break;
        }
    }
  while (parse_status == 0);

  unwind_protect::run_frame (uwp_frame);

  return retval;
}

octave_value
eval_string (const std::string& s, bool silent, int& parse_status)
{
  octave_value retval;

  octave_value_list tmp = eval_string (s, silent, parse_status, 1);

  if (! tmp.empty ())
    retval = tmp(0);

  return retval;
}

static octave_value_list
eval_string (const octave_value& arg, bool silent, int& parse_status,
	     int nargout)
{
  std::string s = arg.string_value ();

  if (error_state)
    {
      error ("eval: expecting std::string argument");
      return octave_value (-1);
    }

  return eval_string (s, silent, parse_status, nargout);
}

DEFUN (eval, args, nargout,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} eval (@var{try}, @var{catch})\n\
Parse the string @var{try} and evaluate it as if it were an Octave\n\
program.  If that fails, evaluate the optional string @var{catch}.\n\
The string @var{try} is evaluated in the current context,\n\
so any results remain available after @code{eval} returns.\n\
\n\
The following example makes the variable @var{a} with the approximate\n\
value 3.1416 available.\n\
\n\
@example\n\
eval(\"a = acos(-1);\");\n\
@end example\n\
\n\
If an error occurs during the evaluation of @var{try} the @var{catch}\n\
string is evaluated, as the following example shows:\n\
\n\
@example\n\
eval ('error (\"This is a bad example\");',\n\
      'printf (\"This error occurred:\\n%s\\n\", lasterr ());');\n\
     @print{} This error occurred:\n\
        This is a bad example\n\
@end example\n\
@end deftypefn")
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin > 0)
    {
      unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

      if (nargin > 1)
	{
	  unwind_protect::protect_var (buffer_error_messages);
	  buffer_error_messages++;
	}

      int parse_status = 0;

      octave_value_list tmp = eval_string (args(0), nargout > 0,
					   parse_status, nargout);

      if (nargin > 1 && (parse_status != 0 || error_state))
	{
	  error_state = 0;

	  // Set up for letting the user print any messages from
	  // errors that occurred in the first part of this eval().

	  buffer_error_messages--;

	  tmp = eval_string (args(1), nargout > 0, parse_status, nargout);

	  if (nargout > 0)
	    retval = tmp;
	}
      else if (nargout > 0)
	retval = tmp;

      unwind_protect::run_frame (uwp_frame);
    }
  else
    print_usage ();

  return retval;
}

/*

%% test/octave.test/eval/eval-1.m
%!#test
%! x = 1;
%! assert(eval ("x"),1);

%% test/octave.test/eval/eval-2.m
%!test
%! x = 1;
%! assert(eval ("x;"));

%% test/octave.test/eval/eval-3.m
%!test
%! x = 1;
%! assert(eval ("x;"),1);

%% FIXME
%% Disable this test as adding the ";" is redundant with eval-1 and
%% in any case is a syntax error with assert
%% test/octave.test/eval/eval-4.m
%!#test
%! x = 1;
%! assert(eval ("x");,1);

%% test/octave.test/eval/eval-5.m
%!test
%! eval ("flipud = 2;");
%! assert(flipud,2);

%% test/octave.test/eval/eval-6.m
%!function y = f ()
%!  eval ("flipud = 2;");
%!  y = flipud;
%!test
%! assert(f,2);

%% test/octave.test/eval/eval-7.m
%!#test
%! eval ("x = 1");
%! assert(x,1);

%% test/octave.test/eval/eval-8.m
%!test
%! eval ("x = 1;")
%! assert(x,1);

%% test/octave.test/eval/eval-9.m
%!test
%! eval ("x = 1;");
%! assert(x,1);

%% test/octave.test/eval/eval-10.m
%!#test
%! eval ("x = 1")
%! assert(x,1);

%% test/octave.test/eval/eval-11.m
%!test
%! x = 1;
%! y = eval ("x");
%! assert(y,1);

%% test/octave.test/eval/eval-12.m
%!test
%! x = 1;
%! y = eval ("x;");
%! assert(y,1);

%% test/octave.test/eval/eval-13.m
%!test
%! x = 1;
%! y = eval ("x;");
%! assert(y,1);

%% test/octave.test/eval/eval-14.m
%!test
%! x = 1;
%! y = eval ("x");
%! assert(y,1);

*/

DEFUN (assignin, args, ,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} assignin (@var{context}, @var{varname}, @var{value})\n\
Assign @var{value} to @var{varname} in context @var{context}, which\n\
may be either @code{\"base\"} or @code{\"caller\"}.\n\
@end deftypefn")
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin == 3)
    {
      std::string context = args(0).string_value ();

      if (! error_state)
        {
	  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

	  if (context == "caller")
	    octave_call_stack::goto_caller_frame ();
	  else if (context == "base")
	    octave_call_stack::goto_base_frame ();
	  else
	    error ("assignin: context must be \"caller\" or \"base\"");

	  if (! error_state)
	    {
	      unwind_protect::add_fcn (octave_call_stack::pop);

	      std::string nm = args(1).string_value ();

	      if (! error_state)
		{
		  if (valid_identifier (nm))
		    symbol_table::varref (nm) = args(2);
		  else
		    error ("assignin: invalid variable name");
		}
	      else
		error ("assignin: expecting variable name as second argument");
	    }

	  unwind_protect::run_frame (uwp_frame);
	}
      else
        error ("assignin: expecting string as first argument");
    }
  else
    print_usage ();

  return retval;
}

DEFUN (evalin, args, nargout,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {} evalin (@var{context}, @var{try}, @var{catch})\n\
Like @code{eval}, except that the expressions are evaluated in the\n\
context @var{context}, which may be either @code{\"caller\"} or\n\
@code{\"base\"}.\n\
@end deftypefn")
{
  octave_value_list retval;

  int nargin = args.length ();

  if (nargin > 1)
    {
      std::string context = args(0).string_value ();

      if (! error_state)
        {
	  unwind_protect::frame_id_t uwp_frame = unwind_protect::begin_frame ();

	  if (context == "caller")
	    octave_call_stack::goto_caller_frame ();
	  else if (context == "base")
	    octave_call_stack::goto_base_frame ();
	  else
	    error ("evalin: context must be \"caller\" or \"base\"");

	  if (! error_state)
	    {
	      unwind_protect::add_fcn (octave_call_stack::pop);

	      if (nargin > 2)
	        {
		  unwind_protect::protect_var (buffer_error_messages);
		  buffer_error_messages++;
		}

	      int parse_status = 0;

	      octave_value_list tmp = eval_string (args(1), nargout > 0,
						   parse_status, nargout);

	      if (nargout > 0)
		retval = tmp;

	      if (nargin > 2 && (parse_status != 0 || error_state))
		{
		  error_state = 0;

		  // Set up for letting the user print any messages from
		  // errors that occurred in the first part of this eval().

		  buffer_error_messages--;

		  tmp = eval_string (args(2), nargout > 0,
				     parse_status, nargout);

		  retval = (nargout > 0) ? tmp : octave_value_list ();
		}
	    }

	  unwind_protect::run_frame (uwp_frame);
	}
      else
        error ("evalin: expecting string as first argument");
    }
  else
    print_usage ();

  return retval;
}

DEFUN (__parser_debug_flag__, args, nargout,
  "-*- texinfo -*-\n\
@deftypefn {Built-in Function} {@var{old_val} =} __parser_debug_flag__ (@var{new_val}))\n\
Undocumented internal function.\n\
@end deftypefn")
{
  octave_value retval;

  bool debug_flag = octave_debug;

  retval = set_internal_variable (debug_flag, args, nargout,
           			  "__parser_debug_flag__");

  octave_debug = debug_flag;

  return retval;
}

/*
;;; Local Variables: ***
;;; mode: text ***
;;; End: ***
*/

